# -*- coding: utf-8 -*-
"""
Created on Thu Oct 23 17:02:32 2014

@author: kuehn
"""
import numpy as np
import os
#import parameters_ginzburg_asymm_LFP_new_noisy_2015_7_6_6_31_23 as params
import parameters_ginzburg_asymm_LFP_new_noisy_mult_theta as params

from solve_ODE_num_m_and_c_two_pop_new_noisy_mult_theta import integrate_m_c_ode


from ginzburg_theory_osc_input import ginzburg
from UE_analysis import plot_UE
from UE_analysis import plot_mean_surprise
from UE_analysis import plot_UE_comp_sim_theo

E = 0
I = 1
X = 2

EE = 0
EI = 1
II = 2
EX = 3
IX = 4

E1 = 0
E2 = 1
I1 = 2
I2 = 3

def Read(foldername, filename):
    files = os.listdir(foldername)
    print filename
    
    for f in files:    
        if(f.find(filename)!=-1):
            print "File found!"
            print foldername + filename
            stream_in = np.load(foldername + filename)
     
            h0            = stream_in['h0'] 
            omega         = stream_in['omega'] 
            M_0_sim = stream_in['M_0_sim']
            M_1_sim = stream_in['M_1_sim']
            M_2_sim = stream_in['M_2_sim']   
            
            C_0_sim         = stream_in['C_0_sim']
            C_1_sim_check   = stream_in['C_1_sim_check']
            C_1_sim_indie   = stream_in['C_1_sim_indie']
            C_1_sim_chopped = stream_in['C_1_sim_chopped']
            C_2_sim         = stream_in['C_2_sim']
                
            mean_t      = stream_in['mean_t']
            c_t         = stream_in['c_t']
            c_check_f   = stream_in['c_check_f']
            c_indie_f   = stream_in['c_indie_f']    
            c_chopped_f = stream_in['c_chopped_f']
            file_found = 1
            return (h0, omega, 
                    M_0_sim, M_1_sim, M_2_sim, 
                    C_0_sim, C_1_sim_check, C_1_sim_indie, C_1_sim_chopped, C_2_sim, 
                    mean_t, c_t, c_check_f, c_indie_f, c_chopped_f, file_found)
    file_found = 0
    print "File not found."
    return (0., 0., np.zeros(4, dtype=float), np.zeros(4, dtype=float), np.zeros(4, dtype=float), 
            np.zeros(3, dtype=float), np.zeros(3, dtype=float), np.zeros(3, dtype=float), 
            np.zeros(3, dtype=float), np.zeros(3, dtype=float), np.zeros((4,1), dtype=float), 
            np.zeros((3,1),dtype=float), np.zeros((3,1),dtype=float), np.zeros((3,1),dtype=float), 
            np.zeros((3,1),dtype=float), file_found)
      
def glue_read(foldername, filenames):
    N_total = len(filenames)
    
    h0_list            = [] 
    omega_list         = []

    M_0_sim_list = []    
    M_1_sim_list = []
    M_2_sim_list = []    
    
    C_0_sim_list         = []
    C_1_sim_check_list   = []
    C_1_sim_indie_list   = []
    C_1_sim_chopped_list = []
    C_2_sim_list         = []
    
    m_t_list         = []
    c_t_list         = []
    c_check_f_list   = []
    c_indie_f_list   = []
    c_chopped_f_list = []
    
    file_found_list  = []
    
    for ii in range(0,N_total):
        (h0, omega, 
         M_0_sim, M_1_sim, M_2_sim, 
         C_0_sim, C_1_sim_check, C_1_sim_indie,  C_1_sim_chopped, C_2_sim, 
         m_t, c_t, c_check_f, c_indie_f, c_chopped_f, file_found) = Read(foldername, filenames[ii])
        print filenames[ii]
        print ii

        h0_list.append(h0)
        omega_list.append(omega)
        
        M_0_sim_list.append(M_0_sim)        
        M_1_sim_list.append(M_1_sim)
        M_2_sim_list.append(M_2_sim)
        
        C_0_sim_list.append(C_0_sim)
        C_1_sim_check_list.append(C_1_sim_check)
        C_1_sim_indie_list.append(C_1_sim_indie)
        C_1_sim_chopped_list.append(C_1_sim_chopped)
        C_2_sim_list.append(C_2_sim)
        
        m_t_list.append(m_t)
        c_t_list.append(c_t)
        c_check_f_list.append(c_check_f)
        c_indie_f_list.append(c_indie_f)
        c_chopped_f_list.append(c_chopped_f)
        
        file_found_list.append(file_found)

    h0_list    = np.array(h0_list).T
    omega_list = np.array(omega_list).T
    
    M_0_sim_list = np.array(M_0_sim_list).T     
    M_1_sim_list = np.array(M_1_sim_list).T     
    M_2_sim_list = np.array(M_2_sim_list).T

    C_0_sim_list         = np.array(C_0_sim_list).T
    C_1_sim_check_list   = np.array(C_1_sim_check_list).T
    C_1_sim_indie_list   = np.array(C_1_sim_indie_list).T
    C_1_sim_chopped_list = np.array(C_1_sim_chopped_list).T
    C_2_sim_list         = np.array(C_2_sim_list).T

    file_found_list = np.array(file_found_list)

    return (h0_list, omega_list, 
            M_0_sim_list, M_1_sim_list, M_2_sim_list, 
            C_0_sim_list, C_1_sim_check_list, C_1_sim_indie_list, C_1_sim_chopped_list, C_2_sim_list, 
            m_t_list, c_t_list, c_check_f_list, c_indie_f_list, c_chopped_f_list, file_found_list)

def glue_seeds(foldername, freq_max, suffix_list):
    delta_freq = freq_max/10. 
    datafile_names = []
    
    suffix_general = suffix_list[0]
    for k in range(0,21):     #... omega increment k
        #omega is the radian frequency, measured in Hz
        if (k==0): 
            omega = 0. 
            T_total = 30000.
        else:
            T_ext_approx = 1/(k * delta_freq)
            T_ext        = int(T_ext_approx/params.dt_samp) * params.dt_samp
    
            omega        = 1000. * 2* np.pi/T_ext  # 1000.* because dt_samp is measured in ms, but omega must be given in Hz, not in kHz!
            T_total = params.T
        print 'omega=', omega
        
        filename = "plot_data_h0="+str(params.h0_default)+"_omega="+str(omega) +  '_T=' + str(T_total) + suffix_general + ".npz"
            
        datafile_names.append(filename)
    ##############################################################################    
    ### Calculate the result for the first suffix before looping over the rest ###
    ### to initialize M0_av, M1_av, etc. with the right array sizes.           ###
    ##############################################################################
    (h0, omegas, 
     M0_av, M1_av, M2_av, 
     C0_av, C1_check_av, C1_indie_av, C1_chopped_av, C2_av, 
     m_t_av, c_t_av, C_check_f_full_av, C_indie_f_full_av, C_chopped_f_full_av, 
     files_found_sum) = glue_read(datafolder,datafile_names)
    
    for suffix_general in suffix_list[1:]:
        datafile_names = []
        for k in range(0,21):     #... omega increment k
        #omega is the radian frequency, measured in Hz
            if (k==0): 
                omega = 0. 
                T_total = 30000.
            else:
                T_ext_approx = 1/(k * delta_freq)
                T_ext        = int(T_ext_approx/params.dt_samp) * params.dt_samp
    
                omega        = 1000. * 2* np.pi/T_ext  # 1000.* because dt_samp is measured in ms, but omega must be given in Hz, not in kHz!
                T_total = params.T
            print 'omega=', omega
        
            filename = "plot_data_h0="+str(params.h0_default)+"_omega="+str(omega) +  '_T=' + str(T_total) + suffix_general + ".npz"
            
            datafile_names.append(filename)    
    
        (h0, omegas, 
         M0, M1, M2, C0, C1_check, C1_indie, C1_chopped, C2, 
         m_t, c_t, C_check_f_full, C_indie_f_full, C_chopped_f_full, 
         files_found) = glue_read(datafolder,datafile_names)
        ###########################################################
        ### Add results only for those omega for which the      ###
        ### simulation was not interrupted (i.e. files_found=1) ###
        ###########################################################

        M0_av[:,np.nonzero(files_found)] += M0[:,np.nonzero(files_found)]        
        M1_av[:,np.nonzero(files_found)] += M1[:,np.nonzero(files_found)]
        M2_av[:,np.nonzero(files_found)] += M2[:,np.nonzero(files_found)]
        
        C0_av[:,np.nonzero(files_found)]         += C0[:,np.nonzero(files_found)]
        C1_check_av[:,np.nonzero(files_found)]   += C1_check[:,np.nonzero(files_found)]
        C1_indie_av[:,np.nonzero(files_found)]   += C1_indie[:,np.nonzero(files_found)]
        C1_chopped_av[:,np.nonzero(files_found)] += C1_chopped[:,np.nonzero(files_found)]
        C2_av[:,np.nonzero(files_found)]         += C2[:,np.nonzero(files_found)]
        
        print 'np.nonzero(files_found)[0]=', np.nonzero(files_found)[0]        
        
        for ii in np.nonzero(files_found)[0]:
            #If simulations for a certain omega are missing so far, we have to treat this case separately
            if(ii in np.nonzero(files_found_sum)[0]):
                m_t_av[ii] += m_t[ii]
                c_t_av[ii] += c_t[ii]
                
                C_check_f_full_av[ii]   += C_check_f_full[ii] 
                C_indie_f_full_av[ii]   += C_indie_f_full[ii]        
                C_chopped_f_full_av[ii] += C_chopped_f_full[ii]
            else:
                m_t_av[ii] = m_t[ii]
                c_t_av[ii] = c_t[ii]
        
                C_check_f_full_av[ii]   = C_check_f_full[ii] 
                C_indie_f_full_av[ii]   = C_indie_f_full[ii]        
                C_chopped_f_full_av[ii] = C_chopped_f_full[ii]
                        
        files_found_sum += files_found
    
    print 'len(suffix_list)=', len(suffix_list)    
    print "files_found_sum=", files_found_sum
        
    print 'np.nonzero(files_found_sum)=', np.nonzero(files_found_sum)
    print 'np.nonzero(files_found_sum)[0]=', np.nonzero(files_found_sum)[0]    
    
    
    h0     = h0[np.nonzero(files_found_sum)[0]]        # Keep only those values, for which there are actually successfull simulations
    omegas = omegas[np.nonzero(files_found_sum)[0]]        # Keep only those values, for which there are actually successfull simulations
    
    M0_av = M0_av[:,np.nonzero(files_found_sum)[0]]/files_found_sum[np.nonzero(files_found_sum)[0]]
    M1_av = M1_av[:,np.nonzero(files_found_sum)[0]]/files_found_sum[np.nonzero(files_found_sum)[0]]
    M2_av = M2_av[:,np.nonzero(files_found_sum)[0]]/files_found_sum[np.nonzero(files_found_sum)[0]]
    
    C0_av = C0_av[:,np.nonzero(files_found_sum)[0]]/files_found_sum[np.nonzero(files_found_sum)[0]]
    C1_check_av =C1_check_av[:,np.nonzero(files_found_sum)[0]]/files_found_sum[np.nonzero(files_found_sum)[0]]
    C1_indie_av =C1_indie_av[:,np.nonzero(files_found_sum)[0]]/files_found_sum[np.nonzero(files_found_sum)[0]]
    C1_chopped_av = C1_chopped_av[:,np.nonzero(files_found_sum)[0]]/files_found_sum[np.nonzero(files_found_sum)[0]]
    C2_av = C2_av[:,np.nonzero(files_found_sum)[0]]/files_found_sum[np.nonzero(files_found_sum)[0]]
    
    for ii in np.nonzero(files_found_sum)[0]:
        m_t_av[ii] = m_t_av[ii]/files_found_sum[ii]
        c_t_av[ii] = c_t_av[ii]/files_found_sum[ii]    
    
        C_check_f_full_av[ii]   = C_check_f_full_av[ii]/files_found_sum[ii]
        C_indie_f_full_av[ii]   = C_indie_f_full_av[ii]/files_found_sum[ii]
        C_chopped_f_full_av[ii] = C_chopped_f_full_av[ii]/files_found_sum[ii]
    
    return (h0, omegas, 
            M0_av, M1_av, M2_av, 
            C0_av, C1_check_av, C1_indie_av, C1_chopped_av, C2_av, 
            m_t_av, c_t_av, C_check_f_full_av, C_indie_f_full_av, C_chopped_f_full_av)
    
    
datafolder = '../data_manuscript/'
suffix_general = '_mult_theta_2016_7_6_12_10_40'

freq_max   = 0.200            # Maximal frequency in kHz

suffix_list = np.array(['_mult_theta_seed=1_2016_7_6_12_10_40', '_mult_theta_seed=13_2016_7_6_12_10_40', '_mult_theta_seed=25_2016_7_6_12_10_40'])

(h0_new, omegas_new, 
 M_0_sim_new, M_1_sim_new, M_2_sim_new, 
 C_0_sim_new, 
 C_1_sim_check_new, C_1_sim_indie_new, C_1_sim_chopped_new, 
 C_2_sim_new, 
 m_sim_t_new, c_sim_t_new, 
 C_sim_check_f_full_new, C_sim_indie_f_full_new, C_sim_chopped_f_full_new) = glue_seeds(datafolder, freq_max, suffix_list)


p0 = 0.05
T_UE = 10000

index_UE = 2

plot_UE(m_sim_t_new[index_UE][E], np.real(c_sim_t_new[index_UE][E]),params.h0_default, omegas_new[index_UE],T_UE,p0, 30, suffix_general)
plot_mean_surprise(m_sim_t_new[index_UE][E], np.real(c_sim_t_new[index_UE][E]),params.h0_default, omegas_new[index_UE],T_UE, 40, suffix_general)
#######################################
ginz = ginzburg(np.array([params.N_E,params.N_I,params.N_X]), params.J_array, params.K_array, 
                params.m_x, params.theta, np.array([params.sigma_noise_E,params.sigma_noise_I]),
                omega = omegas_new[index_UE], h0 = params.h0_default)
ms, cs = ginz.solve_self_consistently_corr(params.m_exp)
(C_delsig, schwan, schwan1, schwan2, schwan30, schwan31, schwan32, C_S_m, C_S_h, 
 C_a_m) = ginz.C1_linear_perturb_theory(ms, params.tau_m)
dev_mean_freq, ente, gans = ginz.M1_linear_perturb_theory(ms, params.tau_m)    
C_ee_theo = C_delsig[0,0]

t_theo_list = np.linspace(0,2.*np.pi * 1000./omegas_new[index_UE], 1000, endpoint=False)

c_theo_list = np.imag(C_ee_theo * np.exp(1j * omegas_new[index_UE] * t_theo_list/1000.)) + cs[0]
m_theo_list = np.imag(dev_mean_freq[0] * np.exp(1j * omegas_new[index_UE] * t_theo_list/1000.)) + ms[0]
######################################
plot_UE_comp_sim_theo(m_sim_t_new[index_UE][E], np.real(c_sim_t_new[index_UE][E]), 
                      m_theo_list, c_theo_list, 
                      params.h0_default, omegas_new[index_UE], T_UE, p0, 40, suffix_general)