# -*- coding: utf-8 -*-
"""
Created on Thu Oct 23 17:02:32 2014

@author: kuehn
"""
import numpy as np
import os
#import parameters_ginzburg_asymm_LFP_new_noisy_2015_7_6_6_31_23 as params
import parameters_ginzburg_single_pop as params

from solve_ODE_num_m_and_c_single_pop import integrate_m_c_ode
from compute_corr_single_pop import compute

from ginzburg_theory_single_pop import ginzburg
import matplotlib as mp
from matplotlib.pylab import *
from plotfuncs import *
#from plot_binary_single_pop import Plot_Funktion
from plot_ginzburg_osc_input_paper_figures import plot_freq_dependence_mean_corr
#from corr_error_plots import relative_errors
#from UE_analysis_single_pop import UE_prob
#from UE_analysis_single_pop import prob_UE_continuous
#from UE_analysis_single_pop import plot_UE
#from UE_analysis_single_pop import plot_mean_surprise

from scipy import signal

I = 0
X = 1

II = 0
IX = 1

I1 = 0
I2 = 1

def loaddata(dp,h0, omega,T,suffix_general):
    print 'In loaddata!'
    print suffix_general
    print 'omega=', omega
    print 'T=', T
    print 'h0=', h0
    
    files = os.listdir(dp)

    inh1_file = [f for f in files if (f.find('inh1')!=-1 
                 and f.find('omega=' + str(omega) + '_')!=-1 
                 and f.find('T=' + str(T) + '_')!=-1 
                 and f.find('h0=' + str(h0) + '_')!=-1 
                 and f.find(suffix_general)!=-1 
                 and os.stat(dp + f).st_size != 0)]
    inh2_file = [f for f in files if (f.find('inh2')!=-1 
                 and f.find('omega=' + str(omega) + '_')!=-1 
                 and f.find('T=' + str(T) + '_')!=-1 
                 and f.find('h0=' + str(h0) + '_')!=-1 
                 and f.find(suffix_general)!=-1 
                 and os.stat(dp + f).st_size != 0)]    

    if(len(inh1_file)>0):        
        print 'str(omega)=', str(omega)        
        print 'str(T)=', str(T)         
        print 'datapath: ' + dp
        print 'inh1_file: ' + inh1_file[0]
        print 'inh2_file: ' + inh2_file[0]
        m_inh1 = np.loadtxt(dp + inh1_file[0])
        m_inh2 = np.loadtxt(dp + inh2_file[0])  
        return m_inh1, m_inh2
    else:
        return np.zeros(1000, dtype=float), np.zeros(1000, dtype=float)
  

def ft_mean_act(m_inh1, m_inh2, N_one_period):
    """Calculates the Fourier transform of the time-dependent mean activity
    with substracted mean."""
    N_transient = (int(int(10.*params.tau_m/params.dt_samp)/N_one_period)+1) * N_one_period    

    N_ges = len(m_inh1)

    N_number_periods = int((N_ges-N_transient)/N_one_period)
    N_eff = N_number_periods * N_one_period
   
    m_eff = np.zeros((2,N_eff), dtype = float)
    m_eff[I1,:] = m_inh1[N_transient:N_eff+N_transient]
    m_eff[I2,:] = m_inh2[N_transient:N_eff+N_transient]
    
    m_mean = np.zeros((2,N_eff), dtype = float)
    for ii in range(0,2):    
        m_mean[ii,:] = np.mean(m_eff[ii])
    
    m_freq = np.fft.fft(m_eff-m_mean, axis = 1)/N_eff         # In numpy.fft, fft is defined without normalization. 
    print N_eff
    freq = np.fft.fftfreq(N_eff, d=params.dt_samp)*1000
    
    f_welch, m_psp_welch = signal.welch(m_eff - m_mean, 1/params.dt_samp, nperseg=1024, axis = 1)
    
    return (freq, m_freq[I1,:], m_freq[I2,:], m_mean[I1,:], m_mean[I2,:], 
            f_welch, m_psp_welch)
  

def angle_original(angle_trans):
    """Corrects the phase shift due to the choice to take the imaginary value
    instead of the real one for an array of complex numbers."""
    result = np.zeros(len(angle_trans), dtype=float)
    result += ((angle_trans > -np.pi) & (angle_trans <   np.pi/2)) * (angle_trans + np.pi/2)
    result += ((angle_trans >= np.pi/2) & (angle_trans < np.pi))   * (angle_trans - 3*np.pi/2)   
    return result     
    
###################################################################################
### Calculations ##################################################################
###################################################################################
def evaluate(datafolder, h0, omega, n_per_period, T_total, suffix_general):
    """Calls the loaddata-function and calculates the Fourier coefficients
    up to order two for the mean activity and the correlations and also gives
    out the time course of mean activities and correlations averaged
    over periods and, for the correlations, also its Fourier transformation."""
    M_0 = np.zeros(2, dtype=complex)
    M_1 = np.zeros(2, dtype=complex)
    M_2 = np.zeros(2, dtype=complex)

    ##################################################
    ### Read out and analyze nest results: ###########
    ##################################################
    omega_kHz = omega/1000.
    m_inh1, m_inh2 = loaddata(datafolder, h0, omega, T_total, 
                                              suffix_general)

    compute_c = compute(m_exc1, m_exc2, m_inh1, m_inh2, params.tau_m, params.dt_samp)
    #compute_c contains all functions calculating time-dependent zero-time-lag
    #correlations for the simulated data    
    C_0 = compute_c.const_corr(n_per_period)             
    C_1 = np.zeros(1, dtype=complex)
    C_2 = np.zeros(1, dtype=complex)
    
    print 'len(m_inh1)=', len(m_inh1)    
    print 'n_per_period=', n_per_period        
    m_inh1 = m_inh1/(params.N_I*params.frac_rec)
    m_inh2 = m_inh2/(params.N_I*params.frac_rec)
           
    (freq, mi1_f, mi2_f, me1_m, me2_m, mi1_m, mi2_m, f_welch, 
     m_psp_welch) = ft_mean_act(m_inh1, m_inh2, n_per_period)

    freq_corr, c_quer_bare_fs, c_naiv_fs = compute_c.Fourier_corr_quer(n_per_period, 1) #fs means "frequency space"    
            
    mean_per, c_quer = compute_c.compute_corr_ts_directly(n_per_period)

    t_list = np.arange(0,n_per_period) * params.dt_samp        
    C_1[0] = np.mean(c_quer[ii,:] * np.exp(-2j * omega_kHz * t_list))
    C_2[0] = np.mean(c_quer[ii,:] * np.exp(-1j * omega_kHz * t_list))
       
    M_0[I1] = mi1_m[0]
    M_0[I2] = mi2_m[0]
        
    M_1[I1] = mi1_f[len(me1_f)/n_per_period]
    M_1[I2] = mi2_f[len(me1_f)/n_per_period]
    
    M_2[I1] = mi1_f[2.*len(me1_f)/n_per_period]
    M_2[I2] = mi2_f[2.*len(me1_f)/n_per_period]
        
    m_time_dep = np.zeros((2,mean_per.shape[0]),dtype=float)
    m_time_dep[I,:] = 0.5*(mean_per[:,I1] + mean_per[:,I2])        
    c_time_dep = c_quer[EE:EX,:]
    c_freq_dep_full = c_quer_bare_fs - c_naiv_fs
             
    return (M_0, M_1, M_2, C_0, C_1, C_1, C_1, C_2, 
            m_time_dep, c_time_dep, c_freq_dep_full, 
            f_welch, m_psp_welch, freq, me1_f, me2_f, mi1_f, mi2_f)
            
            
def write(foldername,filename, h0, omega, M_0_sim, M_1_sim, M_2_sim, 
          C_0_sim, C_1_sim, C_2_sim, 
          mean_t, c_t, c_f):
    """Writes the data evaluated from the simulation into a npz-file."""
    stream_out = {}
    stream_out['h0']    = h0
    stream_out['omega'] = omega
    
    stream_out['M_0_sim'] = M_0_sim
    stream_out['M_1_sim'] = M_1_sim
    stream_out['M_2_sim'] = M_2_sim    
    
    stream_out['C_0_sim']  = C_0_sim
    stream_out['C_1_sim']  = C_1_sim
    stream_out['C_2_sim']  = C_2_sim
    
    stream_out['mean_t']      = mean_t
    stream_out['c_t']         = c_t
    stream_out['c_check_f']   = c_check_f
    stream_out['c_indie_f']   = c_indie_f    
    stream_out['c_chopped_f'] = c_chopped_f
    
    np.savez(foldername+filename, **stream_out)


def read(foldername, filename):
    """Reads the data evaluated from the simulation into a npz-file."""
    files = os.listdir(foldername)
    print filename
    
    for f in files:    
        if(f.find(filename)!=-1):
            print "File found!"
            print foldername + filename
            stream_in = np.load(foldername + filename)
     
            h0            = stream_in['h0'] 
            omega         = stream_in['omega'] 

            M_0_sim = stream_in['M_0_sim']
            M_1_sim = stream_in['M_1_sim']
            M_2_sim = stream_in['M_2_sim'] 
            
            C_0_sim  = stream_in['C_0_sim']
            C_1_sim  = stream_in['C_1_sim_check']
            C_2_sim  = stream_in['C_2_sim']
                
            mean_t      = stream_in['mean_t']
            c_t         = stream_in['c_t']
            c_f   = stream_in['c_check_f']
            file_found = 1
            return (h0, omega, M_0_sim, M_1_sim, M_2_sim, 
                    C_0_sim, C_1_sim, C_1_sim, C_1_sim, C_2_sim, 
                    mean_t, c_t, c_f, c_f, c_f, file_found)
    file_found = 0
    print "File not found."
    return (0., 0., 
            np.zeros(2, dtype=float), np.zeros(2, dtype=float), 
            np.zeros(2, dtype=float), 
            np.zeros(1, dtype=float), np.zeros(1, dtype=float), 
            np.zeros(1, dtype=float), np.zeros(1, dtype=float), 
            np.zeros(1, dtype=float), 
            np.zeros((2,1), dtype=float), np.zeros((1,1),dtype=float), 
            np.zeros((1,1),dtype=float), np.zeros((1,1),dtype=float), 
            np.zeros((1,1),dtype=float), file_found)
      
def glue_read(foldername, filenames):
    """Opens npz-files containing the statistical evaluations of the 
    simulalations for single frequencies omega and creates an array containing
    all of them."""
    N_total = len(filenames)
    
    h0_list = [] 
    omega_list = []

    M_0_sim_list = []    
    M_1_sim_list = []
    M_2_sim_list = []    
    
    C_0_sim_list = []
    C_1_sim_list = []
    C_2_sim_list = []
    
    m_t_list  = []
    c_t_list  = []
    c_f_list  = []
    file_found_list = []
    
    for ii in range(0,N_total):
        (h0, omega, M_0_sim, M_1_sim, M_2_sim, 
         C_0_sim, C_1_sim_check, C_1_sim_indie,  C_1_sim_chopped, C_2_sim, 
         m_t, c_t, c_check_f, c_indie_f, c_chopped_f, 
         file_found) = read(foldername, filenames[ii])
        print filenames[ii]
        print ii

        h0_list.append(h0)
        omega_list.append(omega)
        
        M_0_sim_list.append(M_0_sim)        
        M_1_sim_list.append(M_1_sim)
        M_2_sim_list.append(M_2_sim)
        
        C_0_sim_list.append(C_0_sim)
        C_1_sim_list.append(C_1_sim_check)
        C_2_sim_list.append(C_2_sim)
        
        m_t_list.append(m_t)
        c_t_list.append(c_t)
        c_f_list.append(c_check_f)
        
        file_found_list.append(file_found)

    h0_list    = np.array(h0_list).T
    omega_list = np.array(omega_list).T
    
    M_0_sim_list = np.array(M_0_sim_list).T     
    M_1_sim_list = np.array(M_1_sim_list).T     
    M_2_sim_list = np.array(M_2_sim_list).T

    C_0_sim_list = (np.array(C_0_sim_list).T).reshape((1,len(omega_list)))
    C_1_sim_list = (np.array(C_1_sim_list).T).reshape((1,len(omega_list)))
    C_2_sim_list = (np.array(C_2_sim_list).T).reshape((1,len(omega_list)))

    file_found_list = np.array(file_found_list)

    return (h0_list, omega_list, M_0_sim_list, M_1_sim_list, M_2_sim_list, 
            C_0_sim_list, C_1_sim_list, C_1_sim_list,  C_1_sim_list, C_2_sim_list, 
            m_t_list, c_t_list, c_f_list, c_f_list, c_f_list, file_found_list)
            
def average_over_seeds(foldername, freq_max, suffix_list):
    """Loads the arrays containing time series, Fourier trafos and Fourier
    coefficients of mean activities and correlations for different seeds
    of the simulations and averages over them."""
    delta_freq = freq_max/10.
    
    def load_npz(suffix_general):
        datafile_names = []    
        for k in range(0,21):     #omega is the radian frequency, measured in Hz
            if (k==0): 
                omega = 0. 
                T_total = 30000.
            else:
                T_ext_approx = 1/(k * delta_freq)
                T_ext = int(T_ext_approx/params.dt_samp) * params.dt_samp
        
                omega = 1000. * 2* np.pi/T_ext  # 1000.* because dt_samp is measured in ms, but omega must be given in Hz, not in kHz!
                T_total = params.T
            print 'omega=', omega
            
            filename = "plot_data_h0="+str(params.h0_default)+"_omega="+str(omega) +  '_T=' + str(T_total) + suffix_general + ".npz"
                
            datafile_names.append(filename)    

        (h0, omegas, M0, M1, M2, C0, 
         C1, C1_indie, C1_chopped, C2, 
         m_t, c_t, C_f_full, C_indie_f_full, C_chopped_f_full, 
         files_found) = glue_read(datafolder,datafile_names)
         
        return (h0, omegas, M0, M1, M2, C0, C1, C1_indie, C1_chopped, C2, 
                m_t, c_t, C_f_full, C_indie_f_full, C_chopped_f_full, files_found)
    
    #Separate the first suffix to create an array you can add on    
    (h0, omegas, M0_av, M1_av, M2_av, 
     C0_av, C1_av, C1_indie_av, C1_chopped_av, C2_av, 
     m_t_av, c_t_av, C_f_full_av, C_indie_f_full_av, C_chopped_f_full_av, 
     files_found_sum) = load_npz(suffix_list[0])
     
    for suffix_general in suffix_list[1:]:
        (h0, omegas, M0, M1, M2, C0, 
         C1, C1_indie, C1_chopped, C2, 
         m_t, c_t, C_f_full, C_indie_f_full, C_chopped_f_full, 
         files_found) = load_npz(suffix_general)
        
        # Add results only for those omega, for which the simulation has been successful (i.e. files_found=1)
        M0_av[:,np.nonzero(files_found)] += M0[:,np.nonzero(files_found)]        
        M1_av[:,np.nonzero(files_found)] += M1[:,np.nonzero(files_found)]
        M2_av[:,np.nonzero(files_found)] += M2[:,np.nonzero(files_found)]
        
        C0_av[:,np.nonzero(files_found)] += C0[:,np.nonzero(files_found)]
        C1_av[:,np.nonzero(files_found)] += C1[:,np.nonzero(files_found)]
        C2_av[:,np.nonzero(files_found)] += C2[:,np.nonzero(files_found)]
        
        print 'np.nonzero(files_found)[0]=', np.nonzero(files_found)[0]        
        
        for ii in np.nonzero(files_found)[0]:
            #If simulations for a certain omega are missing so far, we have to treat this case separately
            if(ii in np.nonzero(files_found_sum)[0]):
                m_t_av[ii] += m_t[ii]
                c_t_av[ii] += c_t[ii]
                C_f_full_av[ii] += C_f_full[ii]
            else:
                m_t_av[ii] = m_t[ii]
                c_t_av[ii] = c_t[ii]
                C_f_full_av[ii]   = C_f_full[ii] 
                
        print 'C2=', C2
        print 'C2_av=', C2_av
        
        print 'files_found=', files_found
        print 'files_found_sum', files_found_sum

        files_found_sum += files_found
    
    print 'len(suffix_list)=', len(suffix_list)    
    print "files_found_sum=", files_found_sum
        
    print 'np.nonzero(files_found_sum)=', np.nonzero(files_found_sum)
    print 'np.nonzero(files_found_sum)[0]=', np.nonzero(files_found_sum)[0]    
    
    h0 = h0[np.nonzero(files_found_sum)[0]] # Keep only those values, for which there are actually successfull simulations
    omegas = omegas[np.nonzero(files_found_sum)[0]]       
    #Normalize all entries to the number of successfull simulations
    M0_av = M0_av[:,np.nonzero(files_found_sum)[0]]/files_found_sum[np.nonzero(files_found_sum)[0]]
    print 'np.nonzero(files_found_sum)=', np.nonzero(files_found_sum)
    M1_av = M1_av[:,np.nonzero(files_found_sum)[0]]/files_found_sum[np.nonzero(files_found_sum)[0]]
    M2_av = M2_av[:,np.nonzero(files_found_sum)[0]]/files_found_sum[np.nonzero(files_found_sum)[0]]
    
    C0_av = C0_av[:,np.nonzero(files_found_sum)[0]]/files_found_sum[np.nonzero(files_found_sum)[0]]
    C1_av = C1_av[:,np.nonzero(files_found_sum)[0]]/files_found_sum[np.nonzero(files_found_sum)[0]]
    C2_av = C2_av[:,np.nonzero(files_found_sum)[0]]/files_found_sum[np.nonzero(files_found_sum)[0]]
    
    for ii in np.nonzero(files_found_sum)[0]:
        m_t_av[ii] = m_t_av[ii]/files_found_sum[ii]
        c_t_av[ii] = c_t_av[ii]/files_found_sum[ii]    
        C_f_full_av[ii]   = C_f_full_av[ii]/files_found_sum[ii]
        
    return (h0, omegas, M0_av, M1_av, M2_av, C0_av, C1_av, C1_av, C1_av, C2_av, 
            m_t_av, c_t_av, C_f_full_av, C_f_full_av, C_f_full_av)
            

def calc_theory_num(N_omegas, freq_max):
#     """Calculates the mean activities and pairwise corellations for one period 
#     after the transient phase numerically and determines the Fourier
#     coefficients up to order 2 for N_omega different perturbing frequencies 
#     equally spaced from 0 to freq_max."""   
    delta_freq  = freq_max/N_omegas
        
    omegas  = np.zeros(N_omegas, dtype=float)
    M0_list = np.zeros((1,N_omegas), dtype=complex)
    M1_list = np.zeros((1,N_omegas), dtype=complex)
    M2_list = np.zeros((1,N_omegas), dtype=complex)
    
    C0_list = np.zeros((2,N_omegas), dtype=complex)
    C1_list = np.zeros((2,N_omegas), dtype=complex)
    C2_list = np.zeros((2,N_omegas), dtype=complex)
    
    t_time_list = []    
    m_time_list = []
    c_time_list = []
    
    for ii in range(0,N_omegas):
        t0 = 0
        N_transient = int(10 * params.tau_m/params.dt_samp) 
        if(ii==0):
            omega        = 0.
            omega_kHz    = 0.
            N_per_period = 100
            N_eff        = N_per_period
        else:
            freq_approx_kHz = ii * delta_freq/1000.
            N_per_period    = int(1./(freq_approx_kHz * params.dt_samp))
            N_eff           = N_per_period
            N_transient     = (int(N_transient/N_per_period)+1.) * N_per_period
                
            omega_kHz = 2. * np.pi/(N_per_period * params.dt_samp)            
            omega     = 2. * np.pi/(N_per_period * params.dt_samp) * 1000.
    
        t1 = (N_transient + N_per_period) * params.dt_samp
        m_linear  = 0 #If 1, in the ODE for the mean activity, nonlinear terms are omitted, if 0, full ODEs are considered
        c_linear  = 0 #If 1, in the ODE for the correlation, nonlinear terms are omitted, if 0, full ODEs are considered
        quadratic = 0 #If 1 and c_linear = 0, in addition to the linear order, the quadratic order is considered in the ODE 
                      #for the correlations. If c_linear = 1, value is irrelevant
        (t_list, m_num_list, c_num_list, 
         m0, c0) = integrate_m_c_ode(t0,t1,params.dt_samp, 
                                     m_linear, c_linear, quadratic,
                                     h0 = params.h0_default, omega = omega)
        
        t_time_list.append(np.array(t_list[N_transient:N_transient + N_eff])-t_list[N_transient])
        m_time_list.append(m_num_list[:,N_transient:N_transient + N_eff])
        c_time_list.append(c_num_list[:,N_transient:N_transient + N_eff])
        
        for jj in range(0,2):        
            C0_list[jj,ii] = np.mean(c_num_list[jj,N_transient:N_transient + N_eff])
            C1_list[jj,ii] = np.mean((c_num_list[jj,N_transient:N_transient + N_eff] - c0[jj]) 
                                      * np.exp(-1j * omega_kHz *t_list[N_transient:N_transient + N_eff]))
            C2_list[jj,ii] = np.mean((c_num_list[jj,N_transient:N_transient + N_eff] - c0[jj]) 
                                      * np.exp(-2j * omega_kHz *t_list[N_transient:N_transient + N_eff]))
        
        print 'M0_list.shape=', M0_list.shape    
        M0_list[0,ii] = np.mean(m_num_list[0,N_transient:N_transient + N_eff])
        M1_list[0,ii] = np.mean((m_num_list[0,N_transient:N_transient + N_eff] - m0[0]) 
                                * np.exp(-1j * omega_kHz *t_list[N_transient:N_transient + N_eff]))
        M2_list[0,ii] = np.mean((m_num_list[0,N_transient:N_transient + N_eff] - m0[0]) 
                                * np.exp(-2j * omega_kHz *t_list[N_transient:N_transient + N_eff]))
        
        omegas[ii] = omega  
    
    return omegas, M0_list, M1_list, M2_list, C0_list, C1_list, C2_list, t_time_list, m_time_list, c_time_list


def calc_theory(N_omega, freq_max):
    #T_ext_min=params.dt_samp * 5     #T should not be chosen to high to have enough "trials", i.e. periods to average over
    omega_ext_max = 1000. * 2* np.pi * 2.* freq_max  # 1000.* because freq_max is given in kHz, but omega is always in Hz.
         
    M0_list = np.zeros((1,N_omega), dtype=complex)    
    M1_list = np.zeros((1,N_omega), dtype=complex)
    C0_list = np.zeros((2,N_omega), dtype=complex)
    C1_list = np.zeros((2,N_omega), dtype=complex)
    
    C1_eigen_list  = np.zeros((2,N_omega), dtype=complex)

    C1_S_m_list = np.zeros((2,N_omega), dtype=complex)    
    C1_S_h_list = np.zeros((2,N_omega), dtype=complex)    
    C1_a_m_list = np.zeros((2,N_omega), dtype=complex)    
    
    omegas_theo  = np.linspace(0.,omega_ext_max, N_omega, endpoint = False)
    
    for l in range(0,N_omega):
        omega = omegas_theo[l]    
        g = ginzburg(np.array([params.N_I,params.N_X]), params.J_array, params.K_array, params.m_x, params.theta, omega = omega)
        
        ms, cs = g.solve_self_consistently_corr(params.m_exp)
        dev_mean_freq, ente, gans = g.mu_frequency_dependent_from_linearization_delsig(ms, params.tau_m)
      
        M1_list[0,l] = dev_mean_freq[0]
        
        ##########################################
        ### For the correlations: ################
        ##########################################
        C_delsig, schwan, C_S_m, C_S_h, C_a_m = g.delta_cquer_same_time_from_linearization_frequencyspace_consistencycheck_delsig(ms, params.tau_m)
        #Fill the list containing the analytically calculated values for c
        C1_list[II,l] = C_delsig[I,I]
        C1_list[IX,l] = C_delsig[I,X]
        
        C1_S_m_list[II,l] = C_S_m[I,I]
        C1_S_m_list[IX,l] = C_S_m[I,X]
       
        C1_S_h_list[II,l] = C_S_h[I,I]
        C1_S_h_list[IX,l] = C_S_h[I,X]         
        
        C1_a_m_list[II,l] = C_a_m[I,I]
        C1_a_m_list[IX,l] = C_a_m[I,X]        
        
        C1_eigen_list[II,l] = schwan[I,I]
        C1_eigen_list[IX,l] = schwan[I,X]        
        
        for ii in range(0,2):        
            C0_list[ii,l] = cs[ii]
        
        M0_list[0,l] = ms
        
    return omegas_theo, M0_list, M1_list, C0_list, C1_list, C1_eigen_list, C1_S_m_list, C1_S_h_list, C1_a_m_list
    
    
def Plot_function_time_domain(omega_list,m_sim_t, c_sim_t, times_num, m_list_num, c_list_num, fig_number, suffix_general):
    print 'In Plot_function_times_domain: omega_list/2pi=', omega_list/(2.*np.pi)
    figurepath = params.figurepath_default + '/Correlation_fixed_omega_time_domain/'
    #omega_list = 2. * np.pi * np.arange(0.,100., 5)
    for jj in range(1,1+fig_number):
        omega = omega_list[jj]
        print 'omega=', omega
        T     = (2. * np.pi/omega) * 1000.
        print 'T=', T
        #times = np.arange(0,T,T/500.)
        times = np.linspace(0,T,500, endpoint = False)
        g = ginzburg(np.array([params.N_I,params.N_X]), params.J_array, params.K_array, params.m_x, params.theta, omega = omega)
        
        cs_ii_list = np.zeros_like(times)
        #m_e_list   = np.zeros_like(times)
        for ii in range(0,len(times)):        
            ms, cs = g.solve_self_consistently_corr(params.m_exp, params.h0_default * np.sin((omega/1000.) * times[ii]))
            cs_ii_list[ii] = cs[II]
          
        times_sim = np.linspace(0,T,len(c_sim_t[jj][II,:]),endpoint = False) 
        
        figure(jj)
        plot(times_sim,c_sim_t[jj][II,:],'.', label='simulation')
        plot(times_num[jj], c_list_num[jj][II,:], label='ode-solver')
        plot(times, cs_ii_list, label='adiabatic')
        title('$c_\mathrm{ee}, f=$'+str(omega/(2.*np.pi)))        
        legend(loc=0)
        
        figurename = 'Correlation_ee_one_period_freq='+str(omega/(2.*np.pi))+'h0='+str(params.h0_default)+'_N_pop=' +'_T='+str(params.T)+suffix_general        
        
        savefig(figurepath + figurename + '.pdf')
        savefig(figurepath + figurename + '.eps') 
        
        figure(30+jj)
        plot(times_sim, m_sim_t[jj][I,:],'.', label='simulation')
        plot(times_num[jj], m_list_num[jj][I,:], label='ode-solver')
        legend(loc=0)
        
def Plots_single_omega_freq_domain(omega_list, C_sim_f, suffix_general):
    figurepath = params.figurepath_default + '/Correlation_fixed_omega_freq_domain/'
    print 'len(C_sim_f)=', len(C_sim_f)
    for ii in range(0,4):
        print 'C_sim_f[ii].shape=', C_sim_f[ii].shape
        freq = np.fft.fftfreq(len(C_sim_f[ii][II,:]), d=params.dt_samp)*1000   
        print 'freq=', omega_list[ii] /(2.*np.pi)
        figure(40+ii)
        plot(freq[1:], np.abs(C_sim_f[ii])[II,1:],'.')
        xlabel('$\omega / 2\pi$ {Hz}')
        ylabel('$|Ft(c_{ee})|$')
        title('Perturbing f='+str(omega_list[ii]/(2.*np.pi)))

        figurename = 'Correlation_ee_frequency_spectrum_freq='+str(omega_list[ii]/(2.*np.pi))+'h0='+str(params.h0_default)+'_N_pop=' +'_T='+str(params.T)+suffix_general        
        
        savefig(figurepath + figurename + '.pdf')
        savefig(figurepath + figurename + '.eps')        

datafolder = '../data_manuscript/'
#suffix_general = '_single_pop_ententest'
#suffix_general = '_single_pop_2015_12_14_10_58_25'
#suffix_general = '_single_pop_2016_2_10_10_41_8'
#suffix_general = '_single_pop_2016_2_15_15_58_4'
#suffix_general = '_single_pop_2016_2_18_9_46_26'
#suffix_general = '_single_pop_2016_4_25_22_58_52'
#suffix_general = '_single_pop_2016_5_4_11_54_49'
#suffix_general = '_single_pop_2016_5_10_15_14_31'
suffix_general = '_single_pop_2016_5_12_12_48_36'
#suffix_general = '_ente'

freq_max   = .600            # Maximal frequency in kHz
delta_freq = freq_max/10. 
suffix_list = ['_single_pop_seed=1_2016_5_10_15_14_31','_single_pop_seed=13_2016_5_12_12_48_36']

(h0_new, omegas_new, 
 M_0_sim_new, M_1_sim_new, M_2_sim_new, 
 C_0_sim_new, C_1_sim_check_new, C_1_sim_indie_new, C_1_sim_chopped_new, C_2_sim_new, 
 m_sim_t_new, c_sim_t_new, 
 C_sim_check_f_full_new, C_sim_indie_f_full_new, 
 C_sim_chopped_f_full_new) = average_over_seeds(datafolder, freq_max, suffix_list)

omegas_theo, m_const_theo, peak_inh_theo, c_const_theo, c_delsig_list, schwan, C_S_m_list, C_S_h_list, C_a_m_list = calc_theory(100, freq_max)
omegas_num, M0_list_num, M1_list_num, M2_list_num, C0_list_num, C1_list_num, C2_list_num, ente1, ente2, ente3 = calc_theory_num(25, 2000 * freq_max)


#==============================================================================
# #Plot_Funktion(omegas, peak_exc1, peak_inh1, corr_nest_ee_check, corr_nest_ei_check, corr_nest_ii_check, corr_nest_ee_indie, corr_nest_ei_indie, corr_nest_ii_indie, corr_nest_ee_chopped, corr_nest_ei_chopped, corr_nest_ii_chopped, omegas_theo, peak_exc_theo, peak_inh_theo, c_delsig_list)
# #print 'peak_exc1 vor dem Einlesen:', peak_exc1
# #Plot_Funktion(omegas, peak_m_value, corr_nest_const, corr_nest_check, corr_nest_indie, corr_nest_chopped, omegas_theo, peak_exc_theo, peak_inh_theo, c_const_theo, c_delsig_list)
#==============================================================================

#relative_errors(omegas_new, M_0_sim_new, M_1_sim_new, M_2_sim_new, C_0_sim_new, C_1_sim_check_new, C_1_sim_indie_new, C_1_sim_chopped_new, C_2_sim_new)

single_pop = 1

plot_collection = plot_freq_dependence_mean_corr(h0_new[0], omegas_new[1:], params.T, 
                               M_0_sim_new[:,1:], M_1_sim_new[:,1:], M_2_sim_new[:,1:], 
                               C_0_sim_new[:,1:], 
                               C_1_sim_check_new[:,1:], 
                               C_2_sim_new[:,1:], 
                               0., 0., omegas_theo, 
                               m_const_theo, peak_inh_theo,
                               c_const_theo, 
                               c_delsig_list, C_S_m_list, C_S_h_list, C_a_m_list,
                               omegas_num[1:], 
                               M0_list_num[:,1:], M1_list_num[:,1:], M2_list_num[:,1:], 
                               C0_list_num[:,1:], C1_list_num[:,1:], C2_list_num[:,1:],
                               single_pop,
                               suffix_general)

plot_collection.plot_first_Fourier_comp_corr_mean(I, 'inh.',II, 'II', 2) #Figure 3
plot_collection.plot_three_Fourier_mean(3)
plot_collection.plot_three_Fourier_corr_comp(II, 'II', 5)    