# -*- coding: utf-8 -*-
"""
Created on Fri May 29 15:42:50 2015

@author: kuehn
"""

from plotfuncs import *

import numpy as np
from scipy.stats import norm

E = 0
I = 1

m_E = 0.2
m_I = 0.2

figurepath = '../figures_manuscript_newly_generated/'
            
########################################################################
### Check, "how rational" j_EI/j_EE is ###
########################################################################
            
#j_EI    = -21.
j_EI = -0.21
#j_EE    = 1.
#j_EE    = 15.
j_EE = 0.01


ratio_E =  j_EI/j_EE

#connec_prob = 0.2
#Number_neurons_pop = 8192
#
#K_EI = int(round(connec_prob*Number_neurons_pop))
#K_EE = K_EI

K_EI = 200.
K_EE = 200.

def find_ratio(ratio, K_jI, K_jE):
    r_I_quer = 1
    while(np.mod(-ratio * r_I_quer,1) > 10. ** (-10) and r_I_quer < K_jI):
        r_I_quer = r_I_quer + 1
    
    if(r_I_quer == K_jI):
        if(np.mod(-ratio * r_I_quer,1) > 10. ** (-10)): #If the ratio is not "rational enough"
            r_E_quer = K_jE
            r_I_quer = K_jI
            print 1        
        else:
            if(-ratio * r_I_quer < K_jE):
                r_E_quer = -ratio * r_I_quer
                print 2
                print r_E_quer
                print -ratio
            else:
                r_E_quer = K_jE
                r_I_quer = K_jI
                print 3
            
    else:
        # Then X can be met multiple times
        if(-ratio * r_I_quer < K_jE):
            r_E_quer = -ratio * r_I_quer
            print 4
        else:
            r_E_quer = K_jE
            r_I_quer = K_jI            
            print 5
    return r_E_quer, r_I_quer
    
r_E_quer_plot, r_I_quer_plot = find_ratio(ratio_E, K_EI, K_EE)

def gauss_fct(x, sigma):
    return 1./(sigma) * norm.pdf(x/(sigma))


def calc_X_Prob(ratio, K_jE, K_jI, j_EI, j_EE):
    r_E_quer, r_I_quer = find_ratio(ratio, K_jI, K_jE)
    
    mult_EE = int(K_jE/r_E_quer)
    mult_EI = int(K_jI/r_I_quer)    
    
    mult_vec   = np.array([mult_EE, mult_EI])
    K_vec      = np.array([K_jE, K_jI])
    r_quer_vec = np.array([r_E_quer, r_I_quer])
    j_vec      = np.array([j_EE, j_EI])
    
    permute = np.argsort(mult_vec)
    
    mult_vec   = mult_vec[permute]
    K_vec      = K_vec[permute]
    r_quer_vec = r_quer_vec[permute]
    j_vec      = j_vec[permute]
    
    mult_min = mult_vec[0]
    mult_max = mult_vec[1]
    
    K_min    = K_vec[0]
    K_max    = K_vec[1]
    
    r_quer_min = r_quer_vec[0]
    r_quer_max = r_quer_vec[1]
    
    j_min      = j_vec[0]    
    j_max      = j_vec[1]
    
    res_min  = K_min - mult_min * r_quer_min
    res_max  = K_max - mult_max * r_quer_max
    
    print 'r_quer_min=', r_quer_min
    print 'r_quer_max=', r_quer_max
    print 'mult_max=', mult_max    
    
    print 'res_min=', res_min
    print 'res_max=', res_max
    
    X_values = np.zeros((r_quer_min, r_quer_max * mult_max), dtype=float)
    Prob_X   = np.zeros((r_quer_min, r_quer_max * mult_max), dtype=float)
    mult     = np.zeros((r_quer_min, r_quer_max * mult_max), dtype=float)
    
    for r_min in range(0,int(r_quer_min)):
        for r_max in range(0,int(r_quer_max)):
            for s in range(0,int(mult_max)):
                X_values[r_min, s * r_quer_max + r_max] = j_min * r_min + j_max * (s * r_quer_max + r_max)
                if(s < mult_max - mult_min):            
                    if(r_min <= res_min):
                        x = mult_min + 1
                    else:
                        x = mult_min
                else:
                    if(r_min <= res_min and r_max <= res_max):
                        x = mult_max -s + 1
                    else:
                        x = mult_max - s
                
                mult[r_min, s * r_quer_max + r_max] = x                
                
                summe = 0.
                for jj in range(0,x):
                    summe = summe + gauss_fct(r_min + jj*r_quer_min - K_min * m_I, np.sqrt(K_min * m_I * (1 - m_I))) * gauss_fct(s * r_quer_max + r_max + jj*r_quer_max - K_max * m_E, np.sqrt(K_max * m_E * (1-m_E)))
                    if(r_min ==1 and s * r_quer_max + r_max ==1):
                        print summe
                Prob_X[r_min, s * r_quer_max + r_max] = summe

    return X_values.flatten(), Prob_X.flatten(), mult.flatten()

rcParams['legend.fontsize'] = 200.
rcParams['axes.labelsize']  = 15.
rcParams['axes.titlesize']  = 15.

X_values, Prob_X, mult = calc_X_Prob(ratio_E, K_EE, K_EI, j_EI, j_EE)


X_values = X_values.flatten()
Prob_X   = Prob_X.flatten()

sigma_intr_exc = np.sqrt(j_EI**2 * K_EI * m_I*(1-m_I) + j_EE**2 * K_EE * m_E*(1-m_E))
mu_exc = j_EI * K_EI * m_I + j_EE * K_EE * m_E
print 'sigma_intr_exc=', sigma_intr_exc

x_list = np.arange(-2000.,0.,0.1)
conv_list = np.zeros_like(x_list)


gaussian_false = np.zeros_like(x_list)
for ii in range(0,len(x_list)):
    gaussian_false[ii] = gauss_fct(x_list[ii] - mu_exc, sigma_intr_exc)
    if(np.mod(ii,10000)==0):    
        print ii

N_sigmas = 5
norm_diff      = np.zeros(N_sigmas, dtype=float)
sigma_list     = np.zeros_like(norm_diff)
conv_listlist  = np.zeros((N_sigmas,len(x_list)),dtype=float)

for jj in range(0,N_sigmas):
    sigma = 0.01 * 10**(0.5*jj) * sigma_intr_exc
    
    for ii in range(0,len(x_list)):
        conv_list[ii] = np.sum(Prob_X * gauss_fct(X_values - x_list[ii],sigma))

    sigma_list[jj] = sigma
    conv_listlist[jj,:] = conv_list

rcParams['legend.fontsize'] = 4

sigma = 0.01 * sigma_intr_exc
for ii in range(0,len(x_list)):
    conv_list[ii] = np.sum(Prob_X * gauss_fct(X_values - x_list[ii],sigma))

plot_y_min = min(np.min(Prob_X),np.min(conv_list),np.min(gaussian_false)) - 0.01 * max(np.max(Prob_X),np.max(conv_list),np.max(gaussian_false)) 
plot_y_max = 1.01 * max(np.max(Prob_X),np.max(conv_list),np.max(gaussian_false))

scale = 1.
width = 6.83 # inches for single column in PLoS

n_horz_panels = 1
n_vert_panels = 1

panel_factory = create_fig_plos(11, scale, width, n_horz_panels, n_vert_panels)

rcParams['legend.fontsize'] = scale*10
rcParams['axes.labelsize']  = scale*10
rcParams['axes.titlesize']  = scale*6

panel_factory.new_panel(0, 0, r' \ ')
index = 0
plot(x_list, conv_listlist[index,:], color = 'blue', label='$\sigma_{\mathrm{noise}}/\sigma_{\mathrm{network}}=$'+str(sigma_list[index]/sigma_intr_exc))
index = 2
plot(x_list, conv_listlist[index,:], color = 'red', label='$\sigma_{\mathrm{noise}}/\sigma_{\mathrm{network}}=$'+str(sigma_list[index]/sigma_intr_exc))
index = 4
plot(x_list, conv_listlist[index,:], color = 'green', label='$\sigma_{\mathrm{noise}}/\sigma_{\mathrm{network}}=$'+str(sigma_list[index]/sigma_intr_exc))
plot(X_values, Prob_X *  r_I_quer_plot/j_EE, '.', color = 'black', label='$\mathrm{without} \ \mathrm{noise}$')
plot(x_list, gaussian_false, color = 'black', label='$\mathrm{Simple} \ \mathrm{Gauss}$')
xlabel('$\mathrm{Input} \ h$')
ylabel('$\mathrm{Probabilities}$')
axis([-13.,-3., plot_y_min, plot_y_max])
legend(loc = 0)

figurename = "Input_different_noise_amplitudes_one_plot_paper"

savefig('../figures_manuscript_newly_generated/Realistic_distribution/' + figurename + '.pdf')
#savefig('../figures_manuscript_newly_generated/Realistic_distribution/' + figurename + '.eps')
plt.savefig('../figures_manuscript_newly_generated/Realistic_distribution/' + figurename+ '.svg', format="svg")
os.system('inkscape --without-gui --export-eps='+'../figures_manuscript_newly_generated/Realistic_distribution/' + figurename+'.eps '+'../figures_manuscript_newly_generated/Realistic_distribution/' + figurename+'.svg')