# -*- coding: utf-8 -*-
"""
Created on Tue Feb  3 11:38:43 2015

@author: kuehn
"""

import numpy as np

I = 0
X = 1

II = 0
IX = 1

I1 = 0
I2 = 1

class compute:
    
    def __init__(self, m_inh1, m_inh2, tau_m, dt_samp):
        self.m_inh1  = m_inh1
        self.m_inh2  = m_inh2
        self.tau_m   = tau_m
        self.dt_samp = dt_samp
        
    def compute_corr_ts_directly(self, N_one_period):
        """Calculates the zero time-lag covariances of the excitatory/inhibitory system
        in time space. For this, we assume that every period (i.e. N_one_period successive data points)
        is a trial and the trials are not correlated."""
        #N_transient = int(100.*self.tau_m/self.dt_samp)
        N_transient = (int(int(10.*self.tau_m/self.dt_samp)/N_one_period)+1) * N_one_period
        #N_transient = int(int(100.*self.tau_m/self.dt_samp)/N_one_period) * N_one_period    #Approximate the transient phase to last for 5*tau_m
        N_ges = len(self.m_inh1)
        N_number_periods = int((N_ges-N_transient)/N_one_period)
    #    N_eff = N_number_periods*N_one_period
        m_sorted      = np.zeros((N_number_periods, N_one_period,4), dtype=float)   #Sorted according to  affiliation to a period
      
        for r in range(0,N_number_periods):                                         #We interprete each period as one realization of the ensemble
            m_sorted[r,:,I1] = self.m_inh1[N_transient+r*N_one_period : N_transient+(r+1)*N_one_period]   
            m_sorted[r,:,I2] = self.m_inh2[N_transient+r*N_one_period : N_transient+(r+1)*N_one_period]
        
        mean_per = np.zeros((N_number_periods,N_one_period,2), dtype=float)      #"per" is for "(one) period" or "per period"    
        for s in range(0,N_one_period):
            for t in range(0,2):
                mean_per[:,s,t] = np.mean(m_sorted[:,s,t])
        
        c_quer = np.mean((m_sorted[:,:,I1] - mean_per[:,:,I1]) * (m_sorted[:,:,I2] - mean_per[:,:,I2]), axis=0)
        
        return mean_per[0,:,:], c_quer
        
    
    def Fourier_corr_quer(self, N_one_period, count):
        """Calculates the zero time-lag covariances of the excitatory/inhibitory system
        in frequency space. For this, we assume that every period (i.e. N_one_period 
        successive data points) is a trial and the trials are not correlated.
        Practically it calculates fft(AB) over the whole time stretch, picks out
        only the frequencies which are integer multiples of 2*pi/T (T the period
        of the perturbation) and substracts A_hat_bar * B_hat_bar, where 
        A_hat_bar and B_hat_bar are the fft of A and B respectively with the coefficients
        belonging to integer multiples of 2*pi/T picked out."""
    #    N_transient = int(10.*tau_m/dt_samp)  #Approximate the transient phase to last for 10*tau_m
#        N_transient = int(int(100.*self.tau_m/self.dt_samp)/N_one_period) * N_one_period    
        N_transient = (int(int(10.*self.tau_m/self.dt_samp)/N_one_period)+1) * N_one_period        
        #print 'N_transient=', N_transient
        N_ges = len(self.m_inh1)
        #print 'N_ges=', N_ges
        
        N_number_periods = int((N_ges-N_transient)/N_one_period)    
        N_eff            = N_number_periods * N_one_period
        print 'N_ges='           , N_ges 
        print 'N_number_periods=', N_number_periods    
        print 'N_eff='           , N_eff
        m_inh1_eff = self.m_inh1[N_transient:N_transient + N_eff]
        m_inh2_eff = self.m_inh2[N_transient:N_transient + N_eff]
    
        mean_inh1 = np.mean(m_inh1_eff)
        mean_inh2 = np.mean(m_inh2_eff)      
        
        nn_ii_quer = np.fft.fft((m_inh1_eff - mean_inh1) * (m_inh2_eff - mean_inh2))/N_eff
        
        nn_ii_quer_periodical_mean = nn_ii_quer [np.arange(0,N_one_period) * N_number_periods] 
        
        mi_f1=np.fft.fft(m_inh1_eff - np.mean(m_inh1_eff))/N_eff
        mi_f2=np.fft.fft(m_inh2_eff - np.mean(m_inh2_eff))/N_eff
       
        mi_f1_periodical_mean = mi_f1[np.arange(0,N_one_period) * N_number_periods]        #suiting to a periodical function with period T_ext        
        mi_f2_periodical_mean = mi_f2[np.arange(0,N_one_period) * N_number_periods]    
    
        ni_ni_quer_periodical_mean = np.zeros(N_one_period, dtype=complex)
        
        for k in range(0,N_one_period):
            summe_ii = 0.
            for l in range(k-(N_one_period-1),k+1):
                if(l >= 0):
                    l_index = l
                else:
                    l_index = l+N_one_period
                summe_ii = summe_ii +  mi_f1_periodical_mean[l_index] * mi_f2_periodical_mean[k-l]
            ni_ni_quer_periodical_mean[k]= summe_ii
            #print 'Faltungsregel vermutlich korrekt.'
        
        freq =  np.fft.fftfreq(N_one_period, d=self.dt_samp)*1000
        
        c_roh       = np.zeros((3,N_one_period), dtype = complex)
        c_roh[II,:] = nn_ii_quer_periodical_mean #- ni_ni_quer_periodical_mean
        
        c_naiv       = np.zeros((3,N_one_period), dtype = complex)
        c_naiv[II,:] = ni_ni_quer_periodical_mean
        
        return freq, c_roh, c_naiv
        
    
        
    def Fourier_corr_quer_indie(self, N_one_period, count):
        """Calculates the zero time-lag covariances of the excitatory/inhibitory system
        in frequency space. For this, we assume that every period (i.e. N_one_period 
        successive data points) is a trial and the trials are not correlated.
        It divides the data in two halfs and calculates the mean acitivies A_bar and B_bar 
        of A and B respectivelz of the first half and computes then the mean of the quantity
        (A - A_bar) * (B - B_bar) over the second half.
        Means are always calculated by computing the fft and then throwing away all contributions
        of frequencies that are no integer multiples of 2*pi/T."""
    #    N_transient = int(10.*tau_m/dt_samp)  #Approximate the transient phase to last for 10*tau_m
#        N_transient = int(int(100.*self.tau_m/self.dt_samp)/N_one_period) * N_one_period
        N_transient = (int(int(10.*self.tau_m/self.dt_samp)/N_one_period)+1) * N_one_period
        #print 'N_transient=', N_transient
        N_ges = len(self.m_inh1)
        #print 'N_ges=', N_ges
        
        N_number_periods        = int((N_ges-N_transient)/N_one_period)
        N_number_periods_first  = N_number_periods/2    
        N_number_periods_second = N_number_periods - N_number_periods_first
        
        N_eff        = N_number_periods * N_one_period    
        N_eff_first  = N_number_periods_first * N_one_period
        N_eff_second = N_number_periods_second * N_one_period
        
        m_inh1_eff_first = self.m_inh1[N_transient:N_transient + N_eff_first]
        m_inh2_eff_first = self.m_inh2[N_transient:N_transient + N_eff_first]
    
        m_inh1_eff_second = self.m_inh1[N_transient + N_eff_first: N_transient + N_eff_first + N_eff_second]
        m_inh2_eff_second = self.m_inh2[N_transient + N_eff_first: N_transient + N_eff_first + N_eff_second]
      
    #####################################################################################################
    ### That works: #####################################################################################
    #####################################################################################################  
            
        mi_f1_first  = np.fft.fft(m_inh1_eff_first)/N_eff_first
        mi_f2_first  = np.fft.fft(m_inh2_eff_first)/N_eff_first
        
        mi_f1_periodical_mean_first = mi_f1_first[np.arange(0,N_one_period) * N_number_periods_first]        #suiting to a periodical function with period T_ext        
        mi_f2_periodical_mean_first = mi_f2_first[np.arange(0,N_one_period) * N_number_periods_first]
    
        mi_f1_periodical_mean_long_second  = np.zeros((N_one_period, N_number_periods_second), dtype=complex)        #suiting to a periodical function with period T_ext        
        mi_f2_periodical_mean_long_second  = np.zeros((N_one_period, N_number_periods_second), dtype=complex)
        
        mi_f1_periodical_mean_long_second[:,0] = mi_f1_periodical_mean_first
        mi_f2_periodical_mean_long_second[:,0] = mi_f2_periodical_mean_first
        
        mi_f1_periodical_mean_long_second = mi_f1_periodical_mean_long_second.flatten()
        mi_f2_periodical_mean_long_second = mi_f2_periodical_mean_long_second.flatten()
        
        print 'mi_f1_periodical_mean_long_second.shape = ', mi_f1_periodical_mean_long_second.shape
        
        nn_ii_quer = np.fft.fft((m_inh1_eff_second - np.fft.ifft(mi_f1_periodical_mean_long_second)*N_eff_second) * (m_inh2_eff_second - np.fft.ifft(mi_f2_periodical_mean_long_second)*N_eff_second))/N_eff_second
        
        nn_ii_quer_periodical_mean = nn_ii_quer [np.arange(0,N_one_period) * N_number_periods_second] 
        
        c_roh = nn_ii_quer_periodical_mean
        
        c_naiv = np.zeros(N_one_period, dtype=complex)
        
        freq   =  np.fft.fftfreq(N_one_period, d=self.dt_samp)*1000
        
        return freq, c_roh, c_naiv
    
    def Fourier_corr_quer_chopped(self, N_one_period, count):
        """This function calculates the correlations of exc-exc, exc-inh and inh-inh neurons.
        It assumes that the data of periods that are separated at least by the transient time
        are uncorrelated and can therefore be regarded as realizations of the same ensemble.
        Averages are always computed by calculating the fft and throwing away all contributions belonging
        to frequencies that are no muktiples of 2*pi/T.  """
    #    N_transient = int(10.*tau_m/dt_samp)  #Approximate the transient phase to last for 10*tau_m
#        N_transient = int(int(10.*self.tau_m/self.dt_samp)/N_one_period) * N_one_period
        N_transient = (int(int(10.*self.tau_m/self.dt_samp)/N_one_period)+1) * N_one_period
        #N_transient = 3
        #print 'N_transient=', N_transient
        N_ges = len(self.m_inh1)
        #print 'N_ges=', N_ges
        
        N_number_periods = int((N_ges-N_transient)/N_one_period)
        
        N_eff                  = N_number_periods * N_one_period    
        N_periods_transient    = (int(N_transient/N_one_period)+1)              #N_periods_transient * T > t_transient
    
        m_inh1_eff = self.m_inh1[N_transient:N_transient + N_eff]
        m_inh2_eff = self.m_inh2[N_transient:N_transient + N_eff]
        
        m_inh1_eff_sorted = np.zeros((N_number_periods,N_one_period), dtype=complex)
        m_inh2_eff_sorted = np.zeros((N_number_periods,N_one_period), dtype=complex)
        
        for ii in range(0,N_one_period):
            m_inh1_eff_sorted[:,ii] = m_inh1_eff [np.arange(0,N_number_periods) * N_one_period + ii]
            m_inh2_eff_sorted[:,ii] = m_inh2_eff [np.arange(0,N_number_periods) * N_one_period + ii]
        
        chose_periods = np.arange(0,N_number_periods,N_periods_transient+1)
        
        N_number_periods = len(chose_periods)                   #Mind the redefinitions!
        N_eff            = N_number_periods * N_one_period    
        
        m_inh1_eff_chosen = m_inh1_eff_sorted[chose_periods,:]
        m_inh2_eff_chosen = m_inh2_eff_sorted[chose_periods,:]
        
        m_inh1_eff = m_inh1_eff_chosen.flatten()
        m_inh2_eff = m_inh2_eff_chosen.flatten()
            
        mean_inh1 = np.mean(m_inh1_eff)
        mean_inh2 = np.mean(m_inh2_eff)      
        
        nn_ii_quer = np.fft.fft((m_inh1_eff - mean_inh1) * (m_inh2_eff - mean_inh2))/N_eff
        
        nn_ii_quer_periodical_mean = nn_ii_quer [np.arange(0,N_one_period) * N_number_periods] 
        
        mi_f1=np.fft.fft(m_inh1_eff - np.mean(m_inh1_eff))/N_eff
        mi_f2=np.fft.fft(m_inh2_eff - np.mean(m_inh2_eff))/N_eff
       
        mi_f1_periodical_mean = mi_f1[np.arange(0,N_one_period) * N_number_periods]        #suiting to a periodical function with period T_ext        
        mi_f2_periodical_mean = mi_f2[np.arange(0,N_one_period) * N_number_periods]    
    
        ni_ni_quer_periodical_mean = np.zeros(N_one_period, dtype=complex)
        
        for k in range(0,N_one_period):
            summe_ii = 0.
            for l in range(k-(N_one_period-1),k+1):
                if(l >= 0):
                    l_index = l
                else:
                    l_index = l+N_one_period
                summe_ii = summe_ii +  mi_f1_periodical_mean[l_index] * mi_f2_periodical_mean[k-l]
            ni_ni_quer_periodical_mean[k]= summe_ii
            #print 'Faltungsregel vermutlich korrekt.'
        
        freq =  np.fft.fftfreq(N_one_period, d=self.dt_samp)*1000
        
        c_roh = nn_ii_quer_periodical_mean #- ni_ni_quer_periodical_mean
        
        c_naiv = ni_ni_quer_periodical_mean
        
        return freq, c_roh, c_naiv
        
    def const_corr(self, N_one_period):
        """Computes the constant part of the correlations by assuming that every period
        (consisting of N_one_period data points) is a independent trial. This is different
        from calculating the mean over the whole time stretch and computing the mean deviation
        of that!"""
        N_transient = (int(int(10.*self.tau_m/self.dt_samp)/N_one_period)+1) * N_one_period        
        N_ges = len(self.m_inh1)
        N_number_periods = int((N_ges-N_transient)/N_one_period)
        print 'N_number_periods=', N_number_periods
        #    N_eff = N_number_periods*N_one_period
        m_sorted      = np.zeros((N_number_periods, N_one_period,2), dtype=float)   #Sorted according to  affiliation to a period
          
        for r in range(0,N_number_periods):                                         #We interprete each period as one realization of the ensemble
            m_sorted[r,:,I1] = self.m_inh1[N_transient+r*N_one_period : N_transient+(r+1)*N_one_period]   
            m_sorted[r,:,I2] = self.m_inh2[N_transient+r*N_one_period : N_transient+(r+1)*N_one_period]
            
        mean_per = np.zeros((N_number_periods,N_one_period,2), dtype=float)      #"per" is for "(one) period" or "per period"    
        for s in range(0,N_one_period):
            for t in range(0,2):
                mean_per[:,s,t]=np.mean(m_sorted[:,s,t])
            
        c_quer_const = np.mean((m_sorted[:,:,I1] - mean_per[:,:,I1]) * (m_sorted[:,:,I2] - mean_per[:,:,I2]))
        
        return c_quer_const