# -*- coding: utf-8 -*-
"""
Created on Thu Oct 23 17:02:32 2014

@author: kuehn
"""
import numpy as np
import os
#import parameters_ginzburg_asymm_LFP_new_noisy_2015_7_6_6_31_23 as params
import parameters_ginzburg_asymm_LFP_new_noisy_mult_theta as params

from solve_ODE_num_m_and_c_two_pop_new_noisy_mult_theta import integrate_m_c_ode
from compute_corr import compute

from ginzburg_theory_osc_input import ginzburg
from plot_binary_var_h0_only_comparison_C1_C2 import Plot_Funktion

from scipy import signal

E = 0
I = 1
X = 2

EE = 0
EI = 1
II = 2
EX = 3
IX = 4

E1 = 0
E2 = 1
I1 = 2
I2 = 3

def loaddata(dp,h0, omega,T,suffix_general):
    print 'In loaddata!'
    print suffix_general
    print 'omega=', omega
    print 'T=', T
    print 'h0=', h0
    
    files = os.listdir(dp)
#    if(T!=0):
    exc1_file = [f for f in files if (f.find('exc1')!=-1 and f.find('omega=' + str(omega) + '_')!=-1 and f.find('T=' + str(T) + '_')!=-1 and f.find('h0=' + str(h0) + '_')!=-1 and f.find(suffix_general)!=-1 and os.stat(dp + f).st_size != 0)]
    exc2_file = [f for f in files if (f.find('exc2')!=-1 and f.find('omega=' + str(omega) + '_')!=-1 and f.find('T=' + str(T) + '_')!=-1 and f.find('h0=' + str(h0) + '_')!=-1 and f.find(suffix_general)!=-1 and os.stat(dp + f).st_size != 0)]
    inh1_file = [f for f in files if (f.find('inh1')!=-1 and f.find('omega=' + str(omega) + '_')!=-1 and f.find('T=' + str(T) + '_')!=-1 and f.find('h0=' + str(h0) + '_')!=-1 and f.find(suffix_general)!=-1 and os.stat(dp + f).st_size != 0)]
    inh2_file = [f for f in files if (f.find('inh2')!=-1 and f.find('omega=' + str(omega) + '_')!=-1 and f.find('T=' + str(T) + '_')!=-1 and f.find('h0=' + str(h0) + '_')!=-1 and f.find(suffix_general)!=-1 and os.stat(dp + f).st_size != 0)]
    
#    else:
#        exc1_file = [f for f in files if (f.find('exc1'+ 'omega_' + str(omega) + '_')!=-1 and f.find(suffix_general)!=-1 and os.stat(dp + f).st_size != 0)]
#        exc2_file = [f for f in files if (f.find('exc2'+ 'omega_' + str(omega) + '_')!=-1 and f.find(suffix_general)!=-1 and os.stat(dp + f).st_size != 0)]
#        inh1_file = [f for f in files if (f.find('inh1'+ 'omega_' + str(omega) + '_')!=-1 and f.find(suffix_general)!=-1 and os.stat(dp + f).st_size != 0)]
#        inh2_file = [f for f in files if (f.find('inh2'+ 'omega_' + str(omega) + '_')!=-1 and f.find(suffix_general)!=-1 and os.stat(dp + f).st_size != 0)]    
    if(len(exc1_file)>0):        
        print 'str(omega)=', str(omega)        
        print 'str(T)=', str(T)         
        print 'datapath: ' + dp
        print 'exc1_file: ' + exc1_file[0]
        print 'exc2_file: ' + exc2_file[0]
        print 'inh1_file: ' + inh1_file[0]
        print 'inh2_file: ' + inh2_file[0]
        m_exc1 = np.loadtxt(dp + exc1_file[0])
        m_exc2 = np.loadtxt(dp + exc2_file[0])
        m_inh1 = np.loadtxt(dp + inh1_file[0])
        m_inh2 = np.loadtxt(dp + inh2_file[0])  
        return m_exc1, m_exc2, m_inh1, m_inh2
    else:
        return np.zeros(1000, dtype=float), np.zeros(1000, dtype=float), np.zeros(1000, dtype=float), np.zeros(1000, dtype=float)

def Peak_finder(freq_list, value_list,N_ext):
    n=len(freq_list)    

    n_max = np.min([np.argsort(abs(value_list))[n-2], np.argsort(abs(value_list))[n-1]])                    #Pick the index belonging to the positive frequency 
    n_max_expect = n/N_ext
    return freq_list[n_max], value_list[n_max_expect]


def Fourier_signal(m_exc1, m_exc2, m_inh1, m_inh2, N_one_period):

    N_transient = (int(int(10.*params.tau_m/params.dt_samp)/N_one_period)+1) * N_one_period    

    N_ges = len(m_exc1)
    print 'N_ges=', N_ges

    N_number_periods = int((N_ges-N_transient)/N_one_period)
    N_eff            = N_number_periods * N_one_period
   
    m_eff       = np.zeros((4,N_eff), dtype = float)     
    m_eff[E1,:] = m_exc1[N_transient:N_eff+N_transient]
    m_eff[E2,:] = m_exc2[N_transient:N_eff+N_transient]
    m_eff[I1,:] = m_inh1[N_transient:N_eff+N_transient]
    m_eff[I2,:] = m_inh2[N_transient:N_eff+N_transient]
    
    m_mean   = np.zeros((4,N_eff), dtype = float)
    for ii in range(0,4):    
        m_mean[ii,:] = np.mean(m_eff[ii])
    
    m_freq=np.fft.fft(m_eff-m_mean, axis = 1)/N_eff         # In numpy.fft, fft is defined without normalization. 
    print N_eff
    freq = np.fft.fftfreq(N_eff, d=params.dt_samp)*1000
    
    f_welch, m_psp_welch = signal.welch(m_eff - m_mean, 1/params.dt_samp, nperseg=1024, axis = 1)
    
    return freq, m_freq[E1,:], m_freq[E2,:], m_freq[I1,:], m_freq[I2,:], m_mean[E1,:], m_mean[E2,:], m_mean[I1,:], m_mean[I2,:], f_welch, m_psp_welch
  

def angle_original(angle_trans):
    result = np.zeros(len(angle_trans), dtype=float)
    result += ((angle_trans > -np.pi) & (angle_trans <   np.pi/2)) * (angle_trans + np.pi/2)
    result += ((angle_trans >= np.pi/2) & (angle_trans < np.pi))   * (angle_trans - 3*np.pi/2)   
    return result     
    
###################################################################################
### Calculations ##################################################################
###################################################################################
def Auswerten(datafolder, h0, omega, n_per_period, T_total, suffix_general):
    peak_m_position = np.zeros(4, dtype=float)
    
    M_0         = np.zeros(4, dtype=complex)
    M_1         = np.zeros(4, dtype=complex)
    M_2         = np.zeros(4, dtype=complex)
    
    C_1_check   = np.zeros(3, dtype=complex)
    C_1_indie   = np.zeros(3, dtype=complex)
    C_1_chopped = np.zeros(3, dtype=complex)    
    C_2         = np.zeros(3, dtype=complex)
    ##################################################
    ### Read out and analyze nest results: ###########
    ##################################################
    omega_kHz = omega/1000.
    #if(omega != 0):
    m_exc1, m_exc2, m_inh1, m_inh2 = loaddata(datafolder, h0, omega, T_total, suffix_general)
    #else:
    #    m_exc1, m_exc2, m_inh1, m_inh2 = loaddata(datafolder,h0, omega,0., suffix_general)
        
    print 'len(m_exc1)=', len(m_exc1)
    print 'n_per_period=', n_per_period        
    m_exc1 = m_exc1/(params.N_E*params.frac_rec)
    m_exc2 = m_exc2/(params.N_E*params.frac_rec)
    m_inh1 = m_inh1/(params.N_I*params.frac_rec)
    m_inh2 = m_inh2/(params.N_I*params.frac_rec)
            
    compute_c = compute(m_exc1, m_exc2, m_inh1, m_inh2, params.tau_m, params.dt_samp)
            
    freq, me1_f, me2_f, mi1_f, mi2_f, me1_m, me2_m, mi1_m, mi2_m, f_welch, m_psp_welch = Fourier_signal(m_exc1, m_exc2, m_inh1, m_inh2, n_per_period)

    freq_corr, c_quer_bare_fs, c_naiv_fs                         = compute_c.Fourier_corr_quer(n_per_period, 1)            #fs means "frequency space"    
    freq_corr_indie, c_quer_bare_fs_indie, c_naiv_fs_indie       = compute_c.Fourier_corr_quer_indie(n_per_period, 1)      #fs means "frequency space"    
    freq_corr_chopped, c_quer_bare_fs_chopped, c_naiv_fs_chopped = compute_c.Fourier_corr_quer_chopped(n_per_period, 1)    #fs means "frequency space"    
            
    mean_per, c_quer = compute_c.compute_corr_ts_directly(n_per_period)

    t_list = np.arange(0,n_per_period) * params.dt_samp        
    #print 'n_per_period=', n_per_period
    for ii in range(0,3):
        C_2[ii]         = np.mean(c_quer[ii,:] * np.exp(-2j * omega_kHz * t_list))
        C_1_check[ii]   = np.mean(c_quer[ii,:] * np.exp(-1j * omega_kHz * t_list))
        C_1_indie[ii]   = np.array(Peak_finder(freq_corr_indie,c_quer_bare_fs_indie[ii,:] - c_naiv_fs_indie[ii,:],n_per_period))[1]
        C_1_chopped[ii] = np.array(Peak_finder(freq_corr_chopped,c_quer_bare_fs_chopped[ii,:] - c_naiv_fs_chopped[ii,:],n_per_period))[1]

    C_0 = compute_c.const_corr(n_per_period)             
            
    peak_m_position[E1] = np.array(Peak_finder(freq,me1_f,n_per_period))[0]
    peak_m_position[E2] = np.array(Peak_finder(freq,me2_f,n_per_period))[0]
    peak_m_position[I1] = np.array(Peak_finder(freq,mi1_f,n_per_period))[0]
    peak_m_position[I2] = np.array(Peak_finder(freq,mi2_f,n_per_period))[0]
    
    M_0[E1] = me1_m[0]
    M_0[E2] = me2_m[0]
    M_0[I1] = mi1_m[0]
    M_0[I2] = mi2_m[0]
        
    M_1[E1] = np.array(Peak_finder(freq,me1_f,n_per_period))[1]
    M_1[E2] = np.array(Peak_finder(freq,me2_f,n_per_period))[1]
    M_1[I1] = np.array(Peak_finder(freq,mi1_f,n_per_period))[1]
    M_1[I2] = np.array(Peak_finder(freq,mi2_f,n_per_period))[1]
    
    M_2[E1] = me1_f[2.*len(me1_f)/n_per_period]
    M_2[E2] = me2_f[2.*len(me1_f)/n_per_period]
    M_2[I1] = mi1_f[2.*len(me1_f)/n_per_period]
    M_2[I2] = mi2_f[2.*len(me1_f)/n_per_period]
        
    print 'mean_per.shape[0]=', mean_per.shape[0]
    m_time_dep      = np.zeros((2,mean_per.shape[0]),dtype=float)
    m_time_dep[E,:] = 0.5*(mean_per[:,E1] + mean_per[:,E2])
    m_time_dep[I,:] = 0.5*(mean_per[:,I1] + mean_per[:,I2])        
    c_time_dep      = c_quer[EE:EX,:]
    c_check_freq_dep_full   = c_quer_bare_fs - c_naiv_fs
    c_indie_freq_dep_full   = c_quer_bare_fs_indie - c_naiv_fs_indie
    c_chopped_freq_dep_full = c_quer_bare_fs_chopped - c_naiv_fs_chopped
             
    return M_0, M_1, M_2, C_0, C_1_check, C_1_indie, C_1_chopped, C_2, m_time_dep, c_time_dep, c_check_freq_dep_full, c_indie_freq_dep_full, c_chopped_freq_dep_full, f_welch, m_psp_welch, freq, me1_f, me2_f, mi1_f, mi2_f

    
def Schreiben(foldername,filename, h0, omega, M_0_sim, M_1_sim, M_2_sim, C_0_sim, C_1_sim_check, C_1_sim_indie, C_1_sim_chopped, C_2_sim, mean_t, c_t, c_check_f, c_indie_f, c_chopped_f):
    stream_out = {}
    stream_out['h0']    = h0
    stream_out['omega'] = omega
    
    stream_out['M_0_sim'] = M_0_sim
    stream_out['M_1_sim'] = M_1_sim
    stream_out['M_2_sim'] = M_2_sim    
    
    stream_out['C_0_sim']         = C_0_sim
    stream_out['C_1_sim_check']   = C_1_sim_check
    stream_out['C_1_sim_indie']   = C_1_sim_indie
    stream_out['C_1_sim_chopped'] = C_1_sim_chopped
    stream_out['C_2_sim']         = C_2_sim
    
    stream_out['mean_t']      = mean_t
    stream_out['c_t']         = c_t
    stream_out['c_check_f']   = c_check_f
    stream_out['c_indie_f']   = c_indie_f    
    stream_out['c_chopped_f'] = c_chopped_f
    
    np.savez(foldername+filename, **stream_out)


def Read(foldername, filename):
    files = os.listdir(foldername)
    print filename
    
    for f in files:    
        if(f.find(filename)!=-1):
            print "Datei gefunden!"
            print foldername + filename
            stream_in = np.load(foldername + filename)
     
            h0            = stream_in['h0'] 
            omega         = stream_in['omega'] 
            #print 'Peak_exc1 neu eingeladen:', stream_in['peak_exc1']
           # m_const           = stream_in['m_const']
            M_0_sim = stream_in['M_0_sim']
            M_1_sim = stream_in['M_1_sim']
            M_2_sim = stream_in['M_2_sim']   
            #print 'Erste beiden Elemente:', peak_exc1[0], ' ' , peak_exc1[1]    
            
            C_0_sim         = stream_in['C_0_sim']
            C_1_sim_check   = stream_in['C_1_sim_check']
            C_1_sim_indie   = stream_in['C_1_sim_indie']
            C_1_sim_chopped = stream_in['C_1_sim_chopped']
            C_2_sim         = stream_in['C_2_sim']
                
            mean_t      = stream_in['mean_t']
            c_t         = stream_in['c_t']
            c_check_f   = stream_in['c_check_f']
            c_indie_f   = stream_in['c_indie_f']    
            c_chopped_f = stream_in['c_chopped_f']
            file_found = 1
            return h0, omega, M_0_sim, M_1_sim, M_2_sim, C_0_sim, C_1_sim_check, C_1_sim_indie, C_1_sim_chopped, C_2_sim, mean_t, c_t, c_check_f, c_indie_f, c_chopped_f, file_found
    file_found = 0
    print "Nicht gefunden."
    return 0., 0., np.zeros(4, dtype=float), np.zeros(4, dtype=float), np.zeros(4, dtype=float), np.zeros(3, dtype=float), np.zeros(3, dtype=float), np.zeros(3, dtype=float), np.zeros(3, dtype=float), np.zeros(3, dtype=float), np.zeros((4,1), dtype=float), np.zeros((3,1),dtype=float), np.zeros((3,1),dtype=float), np.zeros((3,1),dtype=float), np.zeros((3,1),dtype=float), file_found
      
def glue_read(foldername, filenames):
    N_total = len(filenames)
    
    h0_list            = [] 
    omega_list         = []

    M_0_sim_list = []    
    M_1_sim_list = []
    M_2_sim_list = []    
    
    C_0_sim_list         = []
    C_1_sim_check_list   = []
    C_1_sim_indie_list   = []
    C_1_sim_chopped_list = []
    C_2_sim_list         = []
    
    m_t_list         = []
    c_t_list         = []
    c_check_f_list   = []
    c_indie_f_list   = []
    c_chopped_f_list = []
    
    file_found_list  = []
    
    for ii in range(0,N_total):
        h0, omega, M_0_sim, M_1_sim, M_2_sim, C_0_sim, C_1_sim_check, C_1_sim_indie,  C_1_sim_chopped, C_2_sim, m_t, c_t, c_check_f, c_indie_f, c_chopped_f, file_found = Read(foldername, filenames[ii])
        print filenames[ii]
        print ii

        h0_list.append(h0)
        omega_list.append(omega)
        
        M_0_sim_list.append(M_0_sim)        
        M_1_sim_list.append(M_1_sim)
        M_2_sim_list.append(M_2_sim)
        
        C_0_sim_list.append(C_0_sim)
        C_1_sim_check_list.append(C_1_sim_check)
        C_1_sim_indie_list.append(C_1_sim_indie)
        C_1_sim_chopped_list.append(C_1_sim_chopped)
        C_2_sim_list.append(C_2_sim)
        
        m_t_list.append(m_t)
        c_t_list.append(c_t)
        c_check_f_list.append(c_check_f)
        c_indie_f_list.append(c_indie_f)
        c_chopped_f_list.append(c_chopped_f)
        
        file_found_list.append(file_found)

    h0_list    = np.array(h0_list).T
    omega_list = np.array(omega_list).T
    
    M_0_sim_list = np.array(M_0_sim_list).T     
    M_1_sim_list = np.array(M_1_sim_list).T     
    M_2_sim_list = np.array(M_2_sim_list).T

    C_0_sim_list         = np.array(C_0_sim_list).T
    C_1_sim_check_list   = np.array(C_1_sim_check_list).T
    C_1_sim_indie_list   = np.array(C_1_sim_indie_list).T
    C_1_sim_chopped_list = np.array(C_1_sim_chopped_list).T
    C_2_sim_list         = np.array(C_2_sim_list).T

    file_found_list = np.array(file_found_list)

    return h0_list, omega_list, M_0_sim_list, M_1_sim_list, M_2_sim_list, C_0_sim_list, C_1_sim_check_list, C_1_sim_indie_list,  C_1_sim_chopped_list, C_2_sim_list, m_t_list, c_t_list, c_check_f_list, c_indie_f_list, c_chopped_f_list, file_found_list

def glue_seeds(foldername, freq_max, suffix_list):
    datafile_names = []
    
    suffix_general = suffix_list[0]
    h0_max = 10.
    delta_h0 = h0_max/10.
    for k in range(0,11):     #... h0 increment k
        h0 = delta_h0 * k  
        
        filename = "plot_data_h0="+str(h0)+"_omega="+str(params.omega_default) +  '_T=' + str(params.T) + suffix_general + ".npz"
            
        datafile_names.append(filename)    
    #Calculate the result for the first suffix before looping over the rest to initialize M0_av, M1_av, etc. with the right array sizes.
    h0_av, omegas_av, M0_av, M1_av, M2_av, C0_av, C1_check_av, C1_indie_av, C1_chopped_av, C2_av, m_t_av, c_t_av, C_check_f_full_av, C_indie_f_full_av, C_chopped_f_full_av, files_found_sum = glue_read(datafolder,datafile_names)

    print 'm_t_av[10:]=', m_t_av[10:]    
    print 'c_t_av[10:]=', c_t_av[10:]        
    
    print 'len(m_t_av)=', len(m_t_av)
    print 'len(c_t_av)=', len(c_t_av)

    print 'len(C_check_f_full_av)=', len(C_check_f_full_av)
    print 'len(C_indie_f_full_av)=', len(C_indie_f_full_av)
    print 'len(C_chopped_f_full_av)=', len(C_chopped_f_full_av)
    #m_c_array_av = np.array([M0_av, M1_av, M2_av, C0_av, C1_check_av, C1_indie_av, C1_chopped_av, C2_av, np.array(m_t_av), np.array(c_t_av), np.array(C_check_f_full_av), np.array(C_indie_f_full_av), np.array(C_chopped_f_full_av)])
    
    for suffix_general in suffix_list[1:]:
        datafile_names = []
        h0_max = 10.
        delta_h0 = h0_max/10.
        for k in range(0,11):     #... h0 increment k
            h0 = delta_h0 * k  
            
            filename = "plot_data_h0="+str(h0)+"_omega="+str(params.omega_default) +  '_T=' + str(params.T) + suffix_general + ".npz"
            
            datafile_names.append(filename)    
    
        h0, omegas, M0, M1, M2, C0, C1_check, C1_indie, C1_chopped, C2, m_t, c_t, C_check_f_full, C_indie_f_full, C_chopped_f_full, files_found = glue_read(datafolder,datafile_names)
        
        # Add results only for those omega, for which the simulation has been successful (i.e. files_found=1)
        
        h0_av[np.nonzero(files_found)] += h0[np.nonzero(files_found)]        
        omegas_av[np.nonzero(files_found)] += omegas[np.nonzero(files_found)]
        
        M0_av[:,np.nonzero(files_found)] += M0[:,np.nonzero(files_found)]        
        M1_av[:,np.nonzero(files_found)] += M1[:,np.nonzero(files_found)]
        M2_av[:,np.nonzero(files_found)] += M2[:,np.nonzero(files_found)]
        
        C0_av[:,np.nonzero(files_found)]         += C0[:,np.nonzero(files_found)]
        C1_check_av[:,np.nonzero(files_found)]   += C1_check[:,np.nonzero(files_found)]
        C1_indie_av[:,np.nonzero(files_found)]   += C1_indie[:,np.nonzero(files_found)]
        C1_chopped_av[:,np.nonzero(files_found)] += C1_chopped[:,np.nonzero(files_found)]
        C2_av[:,np.nonzero(files_found)]         += C2[:,np.nonzero(files_found)]
        
        print 'np.nonzero(files_found)[0]=', np.nonzero(files_found)[0]        
        
        for ii in np.nonzero(files_found)[0]:
            #If simulations for a certain omega are missing so far, we have to treat this case separately
            if(ii in np.nonzero(files_found_sum)[0]):
                m_t_av[ii] += m_t[ii]
                c_t_av[ii] += c_t[ii]
                
                print 'C_check_f_full_av[ii].shape=', C_check_f_full_av[ii].shape
                print 'C_check_f_full[ii].shape=', C_check_f_full[ii].shape
                
                C_check_f_full_av[ii]   += C_check_f_full[ii] 
                C_indie_f_full_av[ii]   += C_indie_f_full[ii]        
                C_chopped_f_full_av[ii] += C_chopped_f_full[ii]
            else:
                m_t_av[ii] = m_t[ii]
                c_t_av[ii] = c_t[ii]
        
                C_check_f_full_av[ii]   = C_check_f_full[ii] 
                C_indie_f_full_av[ii]   = C_indie_f_full[ii]        
                C_chopped_f_full_av[ii] = C_chopped_f_full[ii]
        
    
        print 'len(c_t[5])=', len(c_t[5])
    
        #m_c_array = np.array([M0, M1, M2, C0, C1_check, C1_indie, C1_chopped, C2, np.array(m_t), np.array(c_t), np.array(C_check_f_full), np.array(C_indie_f_full), np.array(C_chopped_f_full)])
        
        print 'C2=', C2
        print 'C2_av=', C2_av
        
        print 'files_found=', files_found
        print 'files_found_sum', files_found_sum

        
        #m_c_array_av[np.nonzero(files_found)] += m_c_array[np.nonzero(files_found)]  
        files_found_sum += files_found
    
    print 'len(suffix_list)=', len(suffix_list)    
    print "files_found_sum=", files_found_sum
        
    print 'np.nonzero(files_found_sum)=', np.nonzero(files_found_sum)
    print 'np.nonzero(files_found_sum)[0]=', np.nonzero(files_found_sum)[0]    
    
    
    h0_av     = h0_av[np.nonzero(files_found_sum)[0]]/files_found_sum[np.nonzero(files_found_sum)[0]]        # Keep only those values, for which there are actually successfull simulations
    omegas_av = omegas_av[np.nonzero(files_found_sum)[0]]/files_found_sum[np.nonzero(files_found_sum)[0]]       # For the parameters h0, omega, these should be same for all seeds, of course, but this
                                                                                                             # a simple way to get a list of all parameters for which calculations were successfull for at least one seed.    
    M0_av = M0_av[:,np.nonzero(files_found_sum)[0]]/files_found_sum[np.nonzero(files_found_sum)[0]]
    print 'np.nonzero(files_found_sum)=', np.nonzero(files_found_sum)
    print 'M0_av.shape=', M0_av.shape
    M1_av = M1_av[:,np.nonzero(files_found_sum)[0]]/files_found_sum[np.nonzero(files_found_sum)[0]]
    M2_av = M2_av[:,np.nonzero(files_found_sum)[0]]/files_found_sum[np.nonzero(files_found_sum)[0]]
    
    C0_av = C0_av[:,np.nonzero(files_found_sum)[0]]/files_found_sum[np.nonzero(files_found_sum)[0]]
    print 'C0_av.shape=', C0_av.shape 
    C1_check_av =C1_check_av[:,np.nonzero(files_found_sum)[0]]/files_found_sum[np.nonzero(files_found_sum)[0]]
    C1_indie_av =C1_indie_av[:,np.nonzero(files_found_sum)[0]]/files_found_sum[np.nonzero(files_found_sum)[0]]
    C1_chopped_av = C1_chopped_av[:,np.nonzero(files_found_sum)[0]]/files_found_sum[np.nonzero(files_found_sum)[0]]
    C2_av = C2_av[:,np.nonzero(files_found_sum)[0]]/files_found_sum[np.nonzero(files_found_sum)[0]]
    
    for ii in np.nonzero(files_found_sum)[0]:
        m_t_av[ii] = m_t_av[ii]/files_found_sum[ii]
        c_t_av[ii] = c_t_av[ii]/files_found_sum[ii]    
    
        C_check_f_full_av[ii]   = C_check_f_full_av[ii]/files_found_sum[ii]
        C_indie_f_full_av[ii]   = C_indie_f_full_av[ii]/files_found_sum[ii]
        C_chopped_f_full_av[ii] = C_chopped_f_full_av[ii]/files_found_sum[ii]
    
    return h0_av, omegas_av, M0_av, M1_av, M2_av, C0_av, C1_check_av, C1_indie_av, C1_chopped_av, C2_av, m_t_av, c_t_av, C_check_f_full_av, C_indie_f_full_av, C_chopped_f_full_av

def Calc_theory_num(N_h0, h0_max):
    
    delta_h0  = h0_max/N_h0
    
    h0_list = np.zeros(N_h0, dtype=float)
    M0_list = np.zeros((2,N_h0), dtype=complex)
    M1_list = np.zeros((2,N_h0), dtype=complex)
    M2_list = np.zeros((2,N_h0), dtype=complex)
    
    C0_list = np.zeros((5,N_h0), dtype=complex)
    C1_list = np.zeros((5,N_h0), dtype=complex)
    C2_list = np.zeros((5,N_h0), dtype=complex)
    
    t_time_list = []    
    m_time_list = []
    c_time_list = []
    
    omega = params.omega_default    

    t0 = 0
        
    N_transient = int(10 * params.tau_m/params.dt_samp) 
    
    freq_approx_kHz = omega/(1000. * 2.*np.pi)
    N_per_period    = int(1./(freq_approx_kHz * params.dt_samp))
    N_eff           = N_per_period
    N_transient     = (int(N_transient/N_per_period)+1.) * N_per_period
                
    omega_kHz    = 2. * np.pi/(N_per_period * params.dt_samp)            
    omega        = 2. * np.pi/(N_per_period * params.dt_samp) * 1000.
    
    print 'omega=', omega    
    
    t1 = (N_transient + N_per_period) * params.dt_samp
        
    for ii in range(0,N_h0):
        h0 = ii * delta_h0            
        m_linear  = 0
        c_linear  = 0
        quadratic = 0
        t_list, m_num_list, c_num_list, m0, c0 = integrate_m_c_ode(t0,t1,params.dt_samp, m_linear, c_linear, quadratic, h0 = h0, omega = omega)
        
        t_time_list.append(np.array(t_list[N_transient:N_transient + N_eff])-t_list[N_transient])
        m_time_list.append(m_num_list[:,N_transient:N_transient + N_eff])
        c_time_list.append(c_num_list[:,N_transient:N_transient + N_eff])
        
        for jj in range(0,5):        
            C0_list[jj,ii] = np.mean(c_num_list[jj,N_transient:N_transient + N_eff])
            C1_list[jj,ii]  = np.mean((c_num_list[jj,N_transient:N_transient + N_eff] - c0[jj]) *  np.exp(-1j * omega_kHz *t_list[N_transient:N_transient + N_eff]))
            C2_list[jj,ii]  = np.mean((c_num_list[jj,N_transient:N_transient + N_eff] - c0[jj]) *  np.exp(-2j * omega_kHz *t_list[N_transient:N_transient + N_eff]))
        #c_Fourier_coeff_one_list[EE,ii]  = Fourier_coeff_1_ee
        for jj in range(0,2):
            M0_list[jj,ii] = np.mean(m_num_list[jj,N_transient:N_transient + N_eff])
            M1_list[jj,ii]  = np.mean((m_num_list[jj,N_transient:N_transient + N_eff] - m0[jj]) *  np.exp(-1j * omega_kHz *t_list[N_transient:N_transient + N_eff]))
            M2_list[jj,ii]  = np.mean((m_num_list[jj,N_transient:N_transient + N_eff] - m0[jj]) *  np.exp(-2j * omega_kHz *t_list[N_transient:N_transient + N_eff]))
        
        h0_list[ii] = h0  
    
    return h0_list, M0_list, M1_list, M2_list, C0_list, C1_list, C2_list, t_time_list, m_time_list, c_time_list


def Calc_theory(h0_max):
    N_h0 = 100
   
    m_const_list  = np.zeros((5,N_h0), dtype=complex)    
    peak_exc_theo = np.zeros(N_h0, dtype=complex)
    peak_inh_theo = np.zeros(N_h0, dtype=complex)
    c_const_list  = np.zeros((5,N_h0), dtype=complex)
    c_delsig_list = np.zeros((5,N_h0), dtype=complex)
    
    C_eigen_list  = np.zeros((5,N_h0), dtype=complex)

    C_S_m_list = np.zeros((5,N_h0), dtype=complex)    
    C_S_h_list = np.zeros((5,N_h0), dtype=complex)    
    C_a_m_list = np.zeros((5,N_h0), dtype=complex)    
        
    
    h0_list  = np.linspace(0, h0_max, N_h0, endpoint=False)
    print 'h0_list=', h0_list
    omega    = params.omega_default    
    
    g = ginzburg(np.array([params.N_E,params.N_I,params.N_X]), params.J_array, params.K_array, params.m_x, params.theta, np.array([params.sigma_noise_E,params.sigma_noise_I]), omega,1.,)
        
    ms, cs = g.solve_self_consistently_corr(params.m_exp)
    mu, sigma2 = g.mu_sigma_from_m_corr(ms, cs)
        
    dev_mean_freq, ente, gans = g.M1_linear_perturb_theory(ms, params.tau_m)    
    C_delsig, schwan, schwan1, schwan2, schwan3, schwan4, schwan5, C_S_m, C_S_h, C_a_m = g.C1_linear_perturb_theory(ms, params.tau_m)
        
    peak_exc_theo = dev_mean_freq[0] * h0_list  #Linear theorie! 
    peak_inh_theo = dev_mean_freq[1] * h0_list
        
    ##########################################
    ### For the correlations: ################
    ##########################################

    #Fill the list containing the analytically calculated values for c
    c_delsig_list[EE,:] = C_delsig[E,E] * h0_list
    c_delsig_list[EI,:] = C_delsig[E,I] * h0_list
    c_delsig_list[II,:] = C_delsig[I,I] * h0_list
    c_delsig_list[EX,:] = C_delsig[E,X] * h0_list
    c_delsig_list[IX,:] = C_delsig[I,X] * h0_list
        
    C_S_m_list[EE,:] = C_S_m[E,E] * h0_list
    C_S_m_list[EI,:] = C_S_m[E,I] * h0_list
    C_S_m_list[II,:] = C_S_m[I,I] * h0_list
    C_S_m_list[EX,:] = C_S_m[E,X] * h0_list
    C_S_m_list[IX,:] = C_S_m[I,X] * h0_list
       
    C_S_h_list[EE,:] = C_S_h[E,E] * h0_list
    C_S_h_list[EI,:] = C_S_h[E,I] * h0_list
    C_S_h_list[II,:] = C_S_h[I,I] * h0_list
    C_S_h_list[EX,:] = C_S_h[E,X] * h0_list
    C_S_h_list[IX,:] = C_S_h[I,X] * h0_list
        
    C_a_m_list[EE,:] = C_a_m[E,E] * h0_list
    C_a_m_list[EI,:] = C_a_m[E,I] * h0_list
    C_a_m_list[II,:] = C_a_m[I,I] * h0_list
    C_a_m_list[EX,:] = C_a_m[E,X] * h0_list
    C_a_m_list[IX,:] = C_a_m[I,X] * h0_list
        
    C_eigen_list[EE,:] = schwan[E,E] * h0_list
    C_eigen_list[EI,:] = schwan[E,I] * h0_list
    C_eigen_list[II,:] = schwan[I,I] * h0_list
    C_eigen_list[EX,:] = schwan[E,X] * h0_list
    C_eigen_list[IX,:] = schwan[I,X] * h0_list     
    
    
    for ii in range(0,5):        
        c_const_list[ii,:] = cs[ii] * np.ones_like(h0_list)
    for ii in range(0,2):        
        m_const_list[ii,:] = ms[ii] * np.ones_like(h0_list)
        
    return h0_list, m_const_list, peak_exc_theo, peak_inh_theo, c_const_list, c_delsig_list, C_eigen_list, C_S_m_list, C_S_h_list, C_a_m_list
    
    
def Plot_function_time_domain(omega_list,m_sim_t, c_sim_t, times_num, m_list_num, c_list_num, fig_number, suffix_general):
    print 'In Plot_function_times_domain: omega_list/2pi=', omega_list/(2.*np.pi)
    figurepath = params.figurepath_default + '/Correlation_fixed_omega_time_domain/'
    #omega_list = 2. * np.pi * np.arange(0.,100., 5)
    for jj in range(1,1+fig_number):
        omega = omega_list[jj]
        print 'omega=', omega
        T     = (2. * np.pi/omega) * 1000.
        print 'T=', T
        #times = np.arange(0,T,T/500.)
        times = np.linspace(0,T,500, endpoint = False)
        g = ginzburg(np.array([params.N_E,params.N_I,params.N_X]), params.J_array, params.K_array, params.m_x, params.theta, omega = omega)
        
        cs_ee_list = np.zeros_like(times)
        #m_e_list   = np.zeros_like(times)
        for ii in range(0,len(times)):        
#            ms, cs = g.solve_self_consistently_corr(params.m_exp, params.h0_default * np.sin((omega/1000.) * times[ii]))
            
            #ms, cs = g.solve_self_consistently_corr(params.m_exp, 0.)
            #print 'cs in Plotfunction_time_domain:', cs            
            cs_ee_list[ii] = cs[EE]
            #m_e_list[ii]   = m[EE]
            #print cs
            #print ms
        #print 'S=', g.susceptibility_corr(ms,cs)
        #ms=    np.array([0.17, 0.08])
        #C_delsig = g.delta_cquer_same_time_from_linearization_frequencyspace_consistencycheck_delsig(params.N, ms, params.h_0, params.tau_m)
        #Fill the list containing the analytically calculated values for c
        #C_delsig[E,E]
        
        #times_sim = np.arange(0,T,T/len(c_ee_t_new[jj])) #geht so nicht (Array einen Eintrag zu lang)
        times_sim = np.linspace(0,T,len(c_sim_t[jj][EE,:]),endpoint = False) 
        print 'Laenge des Simulationsdings:', len(c_sim_t[jj])    
        print 'Laenge von times_sim:',        len(times_sim)
        print 'Laenge der Mean-List:',        len(m_sim_t[jj])        
        
        print 'omega/(2pi)=', omega/(2.*np.pi)
        
        figure(jj)
        plot(times_sim,c_sim_t[jj][EE,:],'.', label='simulation')
        plot(times_num[jj], c_list_num[jj][EE,:], label='ode-solver')
        plot(times, cs_ee_list, label='adiabatic')
        title('$c_\mathrm{ee}, f=$'+str(omega/(2.*np.pi)))        
        legend(loc=0)
        
        figurename = 'Correlation_ee_one_period_freq='+str(omega/(2.*np.pi))+'h0='+str(params.h0_default)+'_N_pop=' +'_T='+str(params.T)+suffix_general        
        
        savefig(figurepath + figurename + '.pdf')
        savefig(figurepath + figurename + '.eps') 
        
        figure(jj+10)
        plot(times_sim,c_sim_t[jj][EI,:],'.', label='simulation')
        plot(times_num[jj], c_list_num[jj][EI,:], label='ode-solver')
        title('$c_\mathrm{ei}$')
        legend(loc=0)        
        
        figure(jj+20)
        plot(times_sim,c_sim_t[jj][II,:],'.', label='simulation')
        plot(times_num[jj], c_list_num[jj][II,:], label='ode-solver')
        title('$c_\mathrm{ii}$')
        legend(loc=0)          
        
        figure(30+jj)
        plot(times_sim, m_sim_t[jj][E,:],'.', label='simulation')
        plot(times_num[jj], m_list_num[jj][E,:], label='ode-solver')
        legend(loc=0)
        
def Plots_single_omega_freq_domain(omega_list, C_sim_f, suffix_general):
    figurepath = params.figurepath_default + '/Correlation_fixed_omega_freq_domain/'
    print 'len(C_sim_f)=', len(C_sim_f)
    for ii in range(0,4):
        print 'C_sim_f[ii].shape=', C_sim_f[ii].shape
        freq = np.fft.fftfreq(len(C_sim_f[ii][EE,:]), d=params.dt_samp)*1000   
        print 'freq=', omega_list[ii] /(2.*np.pi)
        figure(40+ii)
        plot(freq[1:], np.abs(C_sim_f[ii])[EE,1:],'.')
        xlabel('$\omega / 2\pi$ {Hz}')
        ylabel('$|Ft(c_{ee})|$')
        title('Perturbing f='+str(omega_list[ii]/(2.*np.pi)))

        figurename = 'Correlation_ee_frequency_spectrum_freq='+str(omega_list[ii]/(2.*np.pi))+'h0='+str(params.h0_default)+'_N_pop=' +'_T='+str(params.T)+suffix_general        
        
        savefig(figurepath + figurename + '.pdf')
        savefig(figurepath + figurename + '.eps')        

datafolder = '../data_manuscript/'
suffix_general = '_mult_theta_2017_1_4_10_49_33'

freq_max   = 0.200            # Maximal frequency in kHz
h0_max = 10.
suffix_list = np.array(['_mult_theta_seed=1_2017_1_4_10_49_33', '_mult_theta_seed=13_2017_1_4_10_49_33', '_mult_theta_seed=25_2017_1_4_10_49_33'])

h0_new, omegas_new, M_0_sim_new, M_1_sim_new, M_2_sim_new, C_0_sim_new, C_1_sim_check_new, C_1_sim_indie_new, C_1_sim_chopped_new, C_2_sim_new, m_sim_t_new, c_sim_t_new, C_sim_check_f_full_new, C_sim_indie_f_full_new, C_sim_chopped_f_full_new = glue_seeds(datafolder, freq_max, suffix_list)
h0_theo_list, m_const_theo, peak_exc_theo, peak_inh_theo, c_const_theo, c_delsig_list, schwan, C_S_m_list, C_S_h_list, C_a_m_list = Calc_theory(h0_max)
h0_num_list, M0_list_num, M1_list_num, M2_list_num, C0_list_num, C1_list_num, C2_list_num, ente1, ente2, ente3 = Calc_theory_num(25, h0_max)

#==============================================================================
# #Plot_Funktion(omegas, peak_exc1, peak_inh1, corr_nest_ee_check, corr_nest_ei_check, corr_nest_ii_check, corr_nest_ee_indie, corr_nest_ei_indie, corr_nest_ii_indie, corr_nest_ee_chopped, corr_nest_ei_chopped, corr_nest_ii_chopped, omegas_theo, peak_exc_theo, peak_inh_theo, c_delsig_list)
# #print 'peak_exc1 vor dem Einlesen:', peak_exc1
# #Plot_Funktion(omegas, peak_m_value, corr_nest_const, corr_nest_check, corr_nest_indie, corr_nest_chopped, omegas_theo, peak_exc_theo, peak_inh_theo, c_const_theo, c_delsig_list)
#==============================================================================

#relative_errors(omegas_new, M_0_sim_new, M_1_sim_new, M_2_sim_new, C_0_sim_new, C_1_sim_check_new, C_1_sim_indie_new, C_1_sim_chopped_new, C_2_sim_new)


Plot_Funktion(h0_new, 
              M_0_sim_new, M_1_sim_new, M_2_sim_new, 
              C_0_sim_new, 
              C_1_sim_check_new, C_1_sim_indie_new, C_1_sim_chopped_new, 
              C_2_sim_new, 
              h0_theo_list, 
              m_const_theo, peak_exc_theo, peak_inh_theo, 
              c_const_theo, 
              c_delsig_list, C_S_m_list, C_S_h_list, C_a_m_list, 
              h0_num_list, 
              M0_list_num, M1_list_num, M2_list_num, 
              C0_list_num, C1_list_num, C2_list_num, 
              suffix_general)
#==============================================================================
p0 = 0.05
#N  = 2. * np.pi * 1000/(omegas_new[1] * params.dt_samp)
#print 'N=', N
#print 'len(m_sim_t_new[1][E])=', len(m_sim_t_new[1][E])
#t_list = np.linspace(0,2.*np.pi * 1000./omegas_new[1], len(m_sim_t_new[1][E]), endpoint=False)
#
#n0_list, UE_prob_list = UE_prob(m_sim_t_new[1][E], np.real(c_sim_t_new[1][EE]), 1000, p0)

#print 'len(m_sim_t_new[1][E])=', len(ente2[1][E])
#t_list = np.linspace(0,2.*np.pi * 1000./omegas_new[1], len(ente2[1][E]), endpoint=False)
#t_list = np.linspace(0,2.*np.pi * 1000./omegas_num[1], len(ente2[1][E]), endpoint=False)
#
#n0_list, UE_prob_list = UE_prob(ente2[1][E], np.real(ente3[1][EE]), 100000, p0) 
# 
# 
# #for ii in range(0,len(n0_list)):
# #    #n0               = (m_sim_t_new[1][E][ii]**2 + np.real(c_sim_t_new[1][EE][ii]))*1000    
# #    n0               = (m_sim_t_new[1][E][ii]**2)*1000    
# #    UE_prob_list[ii] = prob_UE_continuous(m_sim_t_new[1][E][ii],0.,1000,n0)
# #    n0_list[ii]      = n0
# 
#figure(13)
#plot(t_list, n0_list)
# 
#figure(14)
#plot(t_list, UE_prob_list)
#xlabel('$t [ms]$')
#ylabel('prob for UE')
# 
#figure(15)
##plot(t_list, np.real(c_sim_t_new[1][EE]))
#plot(t_list, np.real(ente3[1][EE]))
#xlabel('$t [ms]$')
#ylabel('$c_{ee}$')
#
#figure(16)
##plot(t_list, np.real(m_sim_t_new[1][E]))
#plot(t_list, np.real(ente2[1][E]))
#xlabel('$t [ms]$')
#ylabel('$m_{e}$')
#
#UE_prob_FT = np.fft.fft(UE_prob_list)
#freq       = np.fft.fftfreq(len(UE_prob_list))
#
#figure(17)
#plot(freq, np.abs(UE_prob_FT),'.')
#==============================================================================

#plot_UE(ente2[1][E], np.real(ente3[1][EE]),omegas_num[1],100000,p0, 10, suffix_general)
#plot_mean_surprise(ente2[1][E], np.real(ente3[1][EE]),omegas_num[1],100000, 20, suffix_general)

#plot_UE(m_sim_t_new[2][E], np.real(c_sim_t_new[2][E]),params.h0_default, omegas_new[2],100000,p0, 30, suffix_general)
#plot_mean_surprise(m_sim_t_new[2][E], np.real(c_sim_t_new[2][E]),params.h0_default, omegas_new[2],100000, 40, suffix_general)

#index_UE = 4
#
#plot_UE(m_sim_t_new[index_UE][E], np.real(c_sim_t_new[index_UE][E]),params.h0_default, omegas_new[index_UE],100000,p0, 30, suffix_general)
#plot_mean_surprise(m_sim_t_new[index_UE][E], np.real(c_sim_t_new[index_UE][E]),params.h0_default, omegas_new[index_UE],100000, 40, suffix_general)
#
#change_meta_html(suffix_general)
#create_clickable(suffix_general,params.T,params.h0_default, omegas_new[index_UE])    

#omegas_num_new, gans0, gans1, gans2, schwan0, schwan1, schwan2, times_num, m_list_num_new, c_list_num_new = Calc_theory_num(5, 500 * freq_max)
#Plot_function_time_domain(omegas_num_new, m_sim_t_new, c_sim_t_new, times_num, m_list_num_new, c_list_num_new, 4, suffix_general)
#Plots_single_omega_freq_domain(omegas_new, C_sim_check_f_full_new, suffix_general)
