# like parameters_ginzburg_symm but with population-specific connection probabilities
import time
import numpy as np
import sys
import scipy.special as sps

n_virtual_procs = 4

msd = 1       # master seed

tau_m = 10.   # ms time constant of neuron
#tau_m = 10000000.0   # ms time constant of neuron

beta = 100.0   # mV^-1 # high slope to obtain saturation so that tanh is effectively a Heaviside function

input_type = 'noise' # 'binary' or 'noise'

T  = 100000.0
#T = 3000038.0   # ms
#T = 3000.0
#T = 30000.

# sizes of excitatory, inhibitory populations, and also of the external population unless input_type = binary
#N = 5000

N_E = 8192
N_I = 8192
N_X = 8192


p_EE = 0.2
p_IE = 0.2

p_EI = 0.2
p_II = 0.2

p_EX = 0.2
p_IX = 0.2


# number of connections per neuron
K_EE = int(round(p_EE*N_E))
K_EI = int(round(p_EI*N_I))
K_IE = int(round(p_IE*N_E))
K_II = int(round(p_II*N_I))
K_EX = int(round(p_EX*N_X))
K_IX = int(round(p_IX*N_X))

m_x_total = 0.5    # mean activity of external neurons

m_x_virtual = 0.25

m_x = m_x_total - m_x_virtual

j_E = 5./np.sqrt(N_E)
j_I = -10./np.sqrt(N_I)

j_EE = j_E
j_IE = j_E

j_EI = j_I
j_II = j_I

j_EX = j_E
j_IX = j_E

J_array = np.array([[j_EE, j_EI, j_EX], [j_IE, j_II, j_IX]])
K_array = np.array([[K_EE, K_EI, K_EX], [K_IE, K_II, K_IX]])

#m_exp = np.array([0.17,0.08])
m_exp = np.array([0.11,0.11])

sigma_network_exp_E = np.sqrt( j_EE**2 * K_EE * m_exp[0] * (1 - m_exp[0]) + j_EI**2 * K_EI * m_exp[1] * (1 - m_exp[1]))
sigma_network_exp_I = np.sqrt( j_IE**2 * K_IE * m_exp[0] * (1 - m_exp[0]) + j_II**2 * K_II * m_exp[1] * (1 - m_exp[1]))

#sigma_noise_E = np.sqrt((sigma_network_exp_E * 0.25)**2 + j_EX**2 * K_EX * 0.1 * 0.9)
#sigma_noise_I = np.sqrt((sigma_network_exp_I * 0.25)**2 + j_EX**2 * K_EX * 0.1 * 0.9)

sigma_noise_E = np.sqrt(j_EX**2 * K_EX * (m_x_total * (1-m_x_total)-m_x * (1-m_x))) 
sigma_noise_I = np.sqrt(j_IX**2 * K_IX * (m_x_total * (1-m_x_total)-m_x * (1-m_x))) 

#sigma_noise_E = 0. 
#sigma_noise_I = 0. 


mu_exp     = np.dot(J_array * K_array,np.hstack((m_exp,m_x)))
sigma2_exp = np.dot(J_array**2 * K_array,np.hstack((m_exp,m_x)) * (1. - np.hstack((m_exp,m_x)))) + np.array([sigma_noise_E**2, sigma_noise_I**2])
sigma_exp  = np.sqrt(sigma2_exp)

print 'sigma_exp=', sigma_exp

theta      = sps.erfcinv(2. * m_exp) * np.sqrt(2.) * sigma_exp + mu_exp


print 'theta - mu_exp=', theta - mu_exp
#theta = np.dot(K_array*J_array,np.hstack((m_exp,m_x)))[0]+0.1     # mV threshold
#theta = np.dot(K_array*J_array,np.hstack((m_exp,m_x))) + 0.1     # mV threshold

d = 0.01       # ms synaptic delay, small, should be equal to h
h = 0.01       # ms resolution

#Parameters for the perturbation:
#h0_default    = 10.
h0_default    = .5                    #The amplitude
omega_default = 2* np.pi * 20.       #The frequency

M1_ext = h0_default/(K_EX * j_E)

dt_samp = h   # sampling interval of activity


frac_rec = 0.5 # fraction of neurons to record from
N_rec_E = int(frac_rec*N_E)
N_rec_I = int(frac_rec*N_I)

record_spin = False # whether to record spins of individual neurons
n_spin = 20 # number of neurons in each population from which to record spins if record_spin==True


time_UTC = ''
for ii in range(0,6):
    time_UTC = time_UTC + '_' + str(time.gmtime(time.time())[ii])
    
datapath_default   = '../data_LFP_new/'
figurepath_default = '../figures_LFP_new'
#suffix_effectively_general = '_2015_7_3_8_34_31'
#suffix_effectively_general = time_UTC
#suffix_effectively_general = "_ente" 
#suffix_effectively_general = "_N="+str(N)+"_j_EE="+str(j_EE)+"_j_EI="+str(j_EI)+"_j_IE="+str(j_IE)+"_j_II="+str(j_II)+"_K_EE="+str(K_EE)+"_K_EI="+str(K_EI)+"_K_IE="+str(K_IE)+"_K_II="+str(K_II)+"_m_x="+str(m_x)+"_m_exp_E="+str(m_exp[0])+"_m_exp_I="+str(m_exp[1])+'sigma_noise_E='+str(sigma_noise_E)+'sigma_noise_I='+str(sigma_noise_I)+"_asymm_ext_effectively_single"
