# like parameters_ginzburg_symm but with population-specific connection probabilities
import time
import numpy as np
import sys
import scipy.special as sps

n_virtual_procs = 4

msd = 1       # master seed

tau_m = 10.   # ms time constant of neuron
#tau_m = 10000000.0   # ms time constant of neuron

beta = 100.0   # mV^-1 # high slope to obtain saturation so that tanh is effectively a Heaviside function

input_type = 'noise' # 'binary' or 'noise'

#T = 3000038.0   # ms
T = 200000.0   # ms
#T = 3000.0
#T = 30000.

# sizes of excitatory, inhibitory populations, and also of the external population unless input_type = binary
#N = 5000

N_E = 1691
#N_E = 5073
N_I = 5000
#N_I = 690
N_X = 500
#N_X = 1500

p_EE = 0.168
p_IE = 0.327

p_EI = 0.5
p_II = 0.1

p_EX = 0.2
p_IX = 0.3


# number of connections per neuron
K_EE = int(round(p_EE*N_E))
K_EI = int(round(p_EI*N_I))
K_IE = int(round(p_IE*N_E))
K_II = int(round(p_II*N_I))
K_EX = int(round(p_EX*N_X))
K_IX = int(round(p_IX*N_X))

m_x = 0.0    # mean activity of external neurons


#j_E = 3.
#j_I = -25.

j_EE = .37
j_IE = .82

j_EI = -.52
j_II = -1.

j_EX = .37
j_IX = .82

J_array = np.array([[j_II, j_IX]])
K_array = np.array([[K_II, K_IX]])

d = 0.01       # ms synaptic delay, small, should be equal to h
h = 0.01       # ms resolution

#m_exp = np.array([0.003,0.017])
m_exp = np.array([0.3])

#Parameters for the perturbation:
#h0_default    = 10.
h0_default    = 10.                    #The amplitude
omega_default = 2* np.pi * 20.       #The frequency

sigma_network_exp_I = np.sqrt(j_II**2 * K_II * m_exp[0] * (1 - m_exp[0]))

sigma_noise_I = sigma_network_exp_I * 1.

mu_exp     = np.dot(J_array * K_array,np.hstack((m_exp,m_x)))
sigma2_exp = np.dot(J_array**2 * K_array,np.hstack((m_exp,m_x)) * (1. - np.hstack((m_exp,m_x)))) + np.array([sigma_noise_I**2])
sigma_exp  = np.sqrt(sigma2_exp)

theta      = sps.erfcinv(2. * m_exp) * np.sqrt(2.) * sigma_exp + mu_exp

dt_samp = h   # sampling interval of activity


frac_rec = 0.5 # fraction of neurons to record from
N_rec_E = int(frac_rec*N_E)
N_rec_I = int(frac_rec*N_I)

record_spin = False # whether to record spins of individual neurons
n_spin = 20 # number of neurons in each population from which to record spins if record_spin==True


time_UTC = ''
for ii in range(0,6):
    time_UTC = time_UTC + '_' + str(time.gmtime(time.time())[ii])
    
datapath_default   = '../data_LFP_new/'
figurepath_default = '../figures_single_pop/'
#suffix_effectively_general = '_2015_7_3_8_34_31'
#suffix_effectively_general = time_UTC
#suffix_effectively_general = "_ente" 
#suffix_effectively_general = "_N="+str(N)+"_j_EE="+str(j_EE)+"_j_EI="+str(j_EI)+"_j_IE="+str(j_IE)+"_j_II="+str(j_II)+"_K_EE="+str(K_EE)+"_K_EI="+str(K_EI)+"_K_IE="+str(K_IE)+"_K_II="+str(K_II)+"_m_x="+str(m_x)+"_m_exp_E="+str(m_exp[0])+"_m_exp_I="+str(m_exp[1])+'sigma_noise_E='+str(sigma_noise_E)+'sigma_noise_I='+str(sigma_noise_I)+"_asymm_ext_effectively_single"
