# -*- coding: utf-8 -*-
"""
Created on Wed Jul  1 14:38:54 2015

@author: kuehn
"""
import Image
from plotfuncs import *
import os
#from parameters_ginzburg_asymm_LFP_new_noisy import suffix_effectively_general
#from parameters_ginzburg_asymm_LFP_new_noisy_mult_theta import figurepath_default
import parameters_ginzburg_asymm_LFP_new_noisy_mult_theta as params

figurepath_default = '../figures_manuscript_newly_generated'

E = 0
I = 1
X = 2

EE = 0
EI = 1
II = 2
EX = 3
IX = 4

E1 = 0
E2 = 1
I1 = 2
I2 = 3

def angle_original(angle_trans):
    result = np.zeros(len(angle_trans), dtype=float)
    result += ((angle_trans > -np.pi) & (angle_trans <   np.pi/2)) * (angle_trans + np.pi/2)
    result += ((angle_trans >= np.pi/2) & (angle_trans < np.pi))   * (angle_trans - 3*np.pi/2)   
    return result     

def Plot_Funktion(h0_sim_list, M_0_sim, peak_m_value, M_2_sim, corr_nest_const, corr_nest_check, corr_nest_indie, corr_nest_chopped, C_2_sim, h0_theo_list, m_const_theo, peak_exc_theo, peak_inh_theo, c_const_theo, c_delsig_list, C_S_m_list, C_S_h_list, C_a_m_list, h0_num_list, M0_num, M1_num, M2_num, C0_num, C1_num, C2_num, suffix_general): 

    corr_nest_ee_check = corr_nest_check[EE,:]    
    corr_nest_ei_check = corr_nest_check[EI,:]
    corr_nest_ii_check = corr_nest_check[II,:]
        
    scale = 1.
    width = 6.83 # inches for single column in PLoS
    
    ###########################################################################
    ### Ratio of second and first harmonics ###################################
    ###########################################################################
    
    n_horz_panels = 2
    n_vert_panels = 1
    
    rcParams['axes.labelsize']  = scale*12
    rcParams['legend.fontsize'] = scale*6
            
    Tafel_Fabrik = create_fig_plos(628, scale, width, n_horz_panels, n_vert_panels)
            
    Tafel_Fabrik.new_panel(0, 0, 'A')
            
    plot(h0_sim_list[1:],np.abs(C_2_sim[EE,1:])/np.abs(corr_nest_ee_check[1:]),'.',markersize=4,linewidth=1.5, color=black, label = 'EE, sim')#, label='$c_\mathrm{'+component_string+'}$')
    plot(h0_num_list[1:],np.abs(C2_num[EE,1:])/np.abs(C1_num[EE,1:]),markersize=4,linewidth=1.5, color=black, label = 'EE, num')#, label='$c_\mathrm{'+component_string+'}, \mathrm{theo, nonlin.}$')
    plot(h0_sim_list[1:],np.abs(C_2_sim[EI,1:])/np.abs(corr_nest_ei_check[1:]),'.',markersize=4,linewidth=1.5, color=midgray, label = 'EI, sim')
    plot(h0_num_list[1:],np.abs(C2_num[EI,1:])/np.abs(C1_num[EI,1:]),markersize=4,linewidth=1.5, color=midgray, label = 'EI, num')
    plot(h0_sim_list[1:],np.abs(C_2_sim[II,1:])/np.abs(corr_nest_ii_check[1:]),'.',markersize=4,linewidth=1.5, color=lightgray, label = 'II, sim')
    plot(h0_num_list[1:],np.abs(C2_num[II,1:])/np.abs(C1_num[II,1:]),markersize=4,linewidth=1.5, color=lightgray, label = 'II, num')    
    
    ymin, ymax = ylim()
    yticks(np.linspace(0.,ymax, 5))
                
    xlabel(r'$h_{\mathrm{ext}}$' )
    ylabel(r'abs($\frac{\hat{C_{2}}}{\hat{C_{1}}}$)')
            
    legend(loc=0)
            
    Tafel_Fabrik.new_panel(1, 0, 'B')    
   
    plot(h0_sim_list[1:],np.abs(M_2_sim[E1,1:] + M_2_sim[E2,1:])/np.abs(peak_m_value[E1,1:]+peak_m_value[E2,1:]),'.',markersize=4,linewidth=1.5, color=black, label = 'E, sim')#, label='$c_\mathrm{'+component_string+'}$')
    plot(h0_num_list[1:],np.abs(M2_num[E,1:])/np.abs(M1_num[E,1:]),markersize=4,linewidth=1.5, color=black, label = 'E, num')#, label='$c_\mathrm{'+component_string+'}, \mathrm{theo, nonlin.}$'         
    plot(h0_sim_list[1:],np.abs(M_2_sim[I1,1:]+M_2_sim[I2,1:])/np.abs(peak_m_value[I1,1:]+peak_m_value[I2,1:]),'.',markersize=4,linewidth=1.5, color=lightgray, label = 'I, sim')
    plot(h0_num_list[1:],np.abs(M2_num[I,1:])/np.abs(M1_num[I,1:]),markersize=4,linewidth=1.5, color=lightgray, label = 'I, num')        
    ymin, ymax = ylim()
    yticks(np.linspace(ymin,ymax, 5))    
            
    xlabel(r'$h_{\mathrm{ext}}$')
    ylabel(r'abs($\frac{\hat{M_{2}}}{\hat{M_{1}}}$)')        
    legend(loc=0)    
    
    Tafel_Fabrik = create_fig_plos(629, scale, width, n_horz_panels, n_vert_panels)
            
    Tafel_Fabrik.new_panel(0, 0, 'A')
            
    plot(h0_sim_list[1:]/params.sigma_exp[E],np.abs(C_2_sim[EE,1:])/np.abs(corr_nest_ee_check[1:]),'.',markersize=4,linewidth=1.5, color=black, label = 'EE, sim')#, label='$c_\mathrm{'+component_string+'}$')
    plot(h0_num_list[1:]/params.sigma_exp[E],np.abs(C2_num[EE,1:])/np.abs(C1_num[EE,1:]),'*',markersize=4,linewidth=1.5, color=black, label = 'EE, num')#, label='$c_\mathrm{'+component_string+'}, \mathrm{theo, nonlin.}$')
   
    ymin, ymax = ylim()
    yticks(np.linspace(0.,ymax, 5))
                
    xlabel(r'$\frac{h_{\mathrm{ext}}}{\sigma_{\mathrm{exc.}}}$' )
    ylabel(r'abs($\frac{\hat{C_{2}}}{\hat{C_{1}}}$)')
            
    legend(loc=0)
            
    Tafel_Fabrik.new_panel(1, 0, 'B')    
   
    plot(h0_sim_list[1:]/params.sigma_exp[E],np.abs(M_2_sim[E1,1:] + M_2_sim[E2,1:])/np.abs(peak_m_value[E1,1:]+peak_m_value[E2,1:]),'.',markersize=4,linewidth=1.5, color=black, label = 'E, sim')#, label='$c_\mathrm{'+component_string+'}$')
    plot(h0_num_list[1:]/params.sigma_exp[E],np.abs(M2_num[E,1:])/np.abs(M1_num[E,1:]),'*',markersize=4,linewidth=1.5, color=black, label = 'E, num')#, label='$c_\mathrm{'+component_string+'}, \mathrm{theo, nonlin.}$'         
    ymin, ymax = ylim()
    yticks(np.linspace(ymin,ymax, 5))    
            
    xlabel(r'$\frac{h_{\mathrm{ext}}}{\sigma_{\mathrm{exc.}}}$' )
    ylabel(r'abs($\frac{\hat{M_{2}}}{\hat{M_{1}}}$)')        
    legend(loc=0)
    
    Tafel_Fabrik = create_fig_plos(630, scale, width, n_horz_panels, n_vert_panels)
            
    Tafel_Fabrik.new_panel(0, 0, 'A')
            
    plot(h0_sim_list[1:]/np.sqrt(params.sigma_exp[E]*params.sigma_exp[I]),np.abs(C_2_sim[EI,1:])/np.abs(corr_nest_ei_check[1:]),'.',markersize=4,linewidth=1.5, color=midgray, label = 'EI, sim')
    plot(h0_num_list[1:]/np.sqrt(params.sigma_exp[E]*params.sigma_exp[I]),np.abs(C2_num[EI,1:])/np.abs(C1_num[EI,1:]),'*',markersize=4,linewidth=1.5, color=midgray, label = 'EI, num')
    
    ymin, ymax = ylim()
    yticks(np.linspace(0.,ymax, 5))
                
    xlabel(r'$\frac{h_{\mathrm{ext}}}{\sqrt{\sigma_{\mathrm{exc.}}\sigma_{\mathrm{inh.}}}}$' )
    ylabel(r'abs($\frac{\hat{C_{2}}}{\hat{C_{1}}}$)')
            
    legend(loc=0)
            
    Tafel_Fabrik.new_panel(1, 0, 'B')

    Tafel_Fabrik = create_fig_plos(631, scale, width, n_horz_panels, n_vert_panels)
            
    Tafel_Fabrik.new_panel(0, 0, 'A')
            
    plot(h0_sim_list[1:]/params.sigma_exp[I],np.abs(C_2_sim[II,1:])/np.abs(corr_nest_ii_check[1:]),'.',markersize=4,linewidth=1.5, color=lightgray, label = 'II, sim')
    plot(h0_num_list[1:]/params.sigma_exp[I],np.abs(C2_num[II,1:])/np.abs(C1_num[II,1:]),'*',markersize=4,linewidth=1.5, color=lightgray, label = 'II, num')    
    
    ymin, ymax = ylim()
    yticks(np.linspace(0.,ymax, 5))
                
    xlabel(r'$\frac{h_{\mathrm{ext}}}{\sigma_{\mathrm{inh.}}}$')
    ylabel(r'abs($\frac{\hat{C_{2}}}{\hat{C_{1}}}$)')
            
    legend(loc=0)
            
    Tafel_Fabrik.new_panel(1, 0, 'B')    
   
    plot(h0_sim_list[1:]/params.sigma_exp[I],np.abs(M_2_sim[I1,1:]+M_2_sim[I2,1:])/np.abs(peak_m_value[I1,1:]+peak_m_value[I2,1:]),'.',markersize=4,linewidth=1.5, color=lightgray, label = 'I, sim')
    plot(h0_num_list[1:]/params.sigma_exp[I],np.abs(M2_num[I,1:])/np.abs(M1_num[I,1:]),'*',markersize=4,linewidth=1.5, color=lightgray, label = 'I, num')        
    ymin, ymax = ylim()
    yticks(np.linspace(ymin,ymax, 5))    
            
    xlabel(r'$\frac{h_{\mathrm{ext}}}{\sigma_{\mathrm{inh.}}}$')
    ylabel(r'abs($\frac{\hat{M_{2}}}{\hat{M_{1}}}$)')        
    legend(loc=0)        
    
    Tafel_Fabrik = create_fig_plos(632, scale, width, n_horz_panels, n_vert_panels)
            
    Tafel_Fabrik.new_panel(0, 0, 'A')
            
    plot(h0_sim_list[1:],np.abs(C_2_sim[EE,1:])/np.abs(corr_nest_ee_check[1:]),'.',markersize=4,linewidth=1.5, color=black, label = 'EE, sim')#, label='$c_\mathrm{'+component_string+'}$')
    plot(h0_num_list[1:],np.abs(C2_num[EE,1:])/np.abs(C1_num[EE,1:]),markersize=4,linewidth=1.5, color=black, label = 'EE, num')#, label='$c_\mathrm{'+component_string+'}, \mathrm{theo, nonlin.}$')
    plot(h0_sim_list[1:],np.abs(C_2_sim[II,1:])/np.abs(corr_nest_ii_check[1:]),'.',markersize=4,linewidth=1.5, color=lightgray, label = 'II, sim')
    plot(h0_num_list[1:],np.abs(C2_num[II,1:])/np.abs(C1_num[II,1:]),markersize=4,linewidth=1.5, color=lightgray, label = 'II, num')    

    #xticks([0.,2.,params.sigma_exp[E]/2.,params.sigma_exp[I]/2.,8.,10.], [0.,2.,r'$\frac{\sigma_{\mathrm{E}}}{2}$',r'$\frac{\sigma_{\mathrm{I}}}{2}$',8.,10.])    
    #xticks([t_c1,40.,60.,t_c2,100.],['$t_{1}=$'+str(t_c1),40.,60.,'$t_{2}=$'+str(t_c2),100.])
    
    ymin, ymax = ylim()
    yticks(np.linspace(0.,ymax, 5))
    
    dot_list_y = np.linspace(0.,ymax,20)        
    plot(np.ones_like(dot_list_y) * params.sigma_exp[E]/2., dot_list_y, '--', linewidth=1, color=black)    
    plot(np.ones_like(dot_list_y) * params.sigma_exp[I]/2., dot_list_y, '--', linewidth=1, color=lightgray)    
                
    xlabel(r'$h_{\mathrm{ext}}$' )
    ylabel(r'abs($\frac{\hat{C_{2}}}{\hat{C_{1}}}$)')
            
    legend(loc=0)
            
    Tafel_Fabrik.new_panel(1, 0, 'B')    
   
    plot(h0_sim_list[1:],np.abs(M_2_sim[E1,1:] + M_2_sim[E2,1:])/np.abs(peak_m_value[E1,1:]+peak_m_value[E2,1:]),'.',markersize=4,linewidth=1.5, color=black, label = 'E, sim')#, label='$c_\mathrm{'+component_string+'}$')
    plot(h0_num_list[1:],np.abs(M2_num[E,1:])/np.abs(M1_num[E,1:]),markersize=4,linewidth=1.5, color=black, label = 'E, num')#, label='$c_\mathrm{'+component_string+'}, \mathrm{theo, nonlin.}$'         
    plot(h0_sim_list[1:],np.abs(M_2_sim[I1,1:]+M_2_sim[I2,1:])/np.abs(peak_m_value[I1,1:]+peak_m_value[I2,1:]),'.',markersize=4,linewidth=1.5, color=lightgray, label = 'I, sim')
    plot(h0_num_list[1:],np.abs(M2_num[I,1:])/np.abs(M1_num[I,1:]),markersize=4,linewidth=1.5, color=lightgray, label = 'I, num')        
    ymin, ymax = ylim()
    yticks(np.linspace(ymin,ymax, 5))    
    
    dot_list_y = np.linspace(0.,ymax,20)        
    plot(np.ones_like(dot_list_y) * params.sigma_exp[E]/2., dot_list_y, '--', linewidth=1, color=black)    
    plot(np.ones_like(dot_list_y) * params.sigma_exp[I]/2., dot_list_y, '--', linewidth=1, color=lightgray)   
        
    xlabel(r'$h_{\mathrm{ext}}$')
    ylabel(r'abs($\frac{\hat{M_{2}}}{\hat{M_{1}}}$)')        
    legend(loc=0)    
   
    figurename = '/Control_linear_approx/Comp_M2_M1_and_C2_C1='+str(params.omega_default) +'_T='+str(params.T)+suffix_general        
            
    savefig(figurepath_default + figurename + '.pdf')
    #savefig(figurepath_default + figurename + '.eps')
    plt.savefig(figurepath_default + figurename+ '.svg', format="svg")
    os.system('inkscape --without-gui --export-eps='+figurepath_default + figurename+'.eps '+figurepath_default + figurename+'.svg')
    