# -*- coding: utf-8 -*-
"""
Created on Wed Jul  1 14:38:54 2015

@author: kuehn
"""
#import Image
from plotfuncs import *
#from parameters_ginzburg_asymm_LFP_new_noisy import suffix_effectively_general
#from parameters_ginzburg_asymm_LFP_new_noisy_mult_theta import figurepath_default
#import parameters_ginzburg_asymm_LFP_new_noisy_mult_theta as params
import os

figurepath_default = '../figures_manuscript_newly_generated'

def angle_original(angle_trans):
    result = np.zeros(len(angle_trans), dtype=float)
    result += ((angle_trans > -np.pi) & (angle_trans <   np.pi/2)) * (angle_trans + np.pi/2)
    result += ((angle_trans >= np.pi/2) & (angle_trans < np.pi))   * (angle_trans - 3*np.pi/2)   
    return result

    
class plot_freq_dependence_mean_corr:
    
    def __init__(self,h_ext,omegas_sim,T_sim, 
                      M0_sim_doubled, M1_sim_doubled, M2_sim_doubled, 
                      C0_sim, C1_sim, C2_sim, 
                      f_res_mean, f_res_corr, omegas_theo, 
                      M0_theo, M1_theo,
                      C0_theo, C1_theo, C1_S_m_theo, C1_S_h_theo, C1_a_m_theo,
                      omegas_num, 
                      M0_num, M1_num, M2_num, 
                      C0_num, C1_num, C2_num,
                      single_pop,
                      suffix_general): 
        self.h_ext = h_ext
        self.omegas_sim = omegas_sim
        self.T_sim = T_sim
        self.C0_sim = C0_sim
        self.C1_sim = C1_sim
        self.C2_sim = C2_sim        
        
        self.f_res_mean = f_res_mean
        self.f_res_corr = f_res_corr        
        self.omegas_theo = omegas_theo

        self.M0_theo = M0_theo        
        self.M1_theo = M1_theo
        
        self.C0_theo = C0_theo        
        self.C1_theo = C1_theo        
        self.C1_S_m_theo = C1_S_m_theo        
        self.C1_S_h_theo = C1_S_h_theo
        self.C1_a_m_theo = C1_a_m_theo
        
        self.omegas_num = omegas_num
    
        self.M0_num = M0_num
        self.M1_num = M1_num
        self.M2_num = M2_num

        self.C0_num = C0_num
        self.C1_num = C1_num
        self.C2_num = C2_num
        
        if(single_pop == 1):
            self.I = 0
            
            self.M0_sim = np.zeros((1,M0_sim_doubled.shape[1]), dtype=complex)
            self.M0_sim[0,:] = (M0_sim_doubled[0,:] + M0_sim_doubled[1,:])/2.    
        
            self.M1_sim = np.zeros((1,M0_sim_doubled.shape[1]), dtype=complex)
            self.M1_sim[0,:] = (M1_sim_doubled[0,:] + M1_sim_doubled[1,:])/2.    
            
            self.M2_sim = np.zeros((1,M0_sim_doubled.shape[1]), dtype=complex)
            self.M2_sim[0,:] = (M2_sim_doubled[0,:] + M2_sim_doubled[1,:])/2.
        else:
            self.E = 0
            self.I = 1
            
            self.M0_sim = np.zeros((2,M0_sim_doubled.shape[1]), dtype=complex)
            self.M0_sim[0,:] = (M0_sim_doubled[0,:] + M0_sim_doubled[1,:])/2.    
            self.M0_sim[1,:] = (M0_sim_doubled[2,:] + M0_sim_doubled[3,:])/2.    
            
            self.M1_sim = np.zeros((2,M1_sim_doubled.shape[1]), dtype=complex)
            self.M1_sim[0,:] = (M1_sim_doubled[0,:] + M1_sim_doubled[1,:])/2.    
            self.M1_sim[1,:] = (M1_sim_doubled[2,:] + M1_sim_doubled[3,:])/2.    
            
            self.M2_sim = np.zeros((2,M2_sim_doubled.shape[1]), dtype=complex)
            self.M2_sim[0,:] = (M2_sim_doubled[0,:] + M2_sim_doubled[1,:])/2.
            self.M2_sim[1,:] = (M2_sim_doubled[2,:] + M2_sim_doubled[3,:])/2.    
            
        self.single_pop = single_pop
        self.suffix_general = suffix_general

        self.scale = 1.
        self.width = 6.83 # inches for single column in PLoS
        
    ###########################################################################
    ### Create compound-figures with mean-activities and correlations #########
    ###########################################################################
    def plot_first_Fourier_comp_corr_mean(self,comp_number_mean, comp_string_mean, comp_number_corr, comp_string_corr, fig_number):        

        Tafel_Fabrik = create_fig_plos(fig_number, self.scale, self.width, 2, 2)
        
        Tafel_Fabrik.new_panel(0, 0, r'A')
        plot(self.omegas_sim/(2*np.pi),np.abs(self.M1_sim[comp_number_mean,:]) * 1000.,'.',
             linewidth=2, color=black, label='$m_\mathrm{'+comp_string_mean+'}$')
        plot(self.omegas_num/(2*np.pi),np.abs(self.M1_num[comp_number_mean,:]) * 1000.,'*',
             linewidth=2, color=black, label='$m_\mathrm{'+comp_string_mean+'}, \mathrm{theo., nonlin.}$')
        plot(self.omegas_theo/(2*np.pi),np.abs(self.M1_theo[comp_number_mean,:]) * 1000./2.,
             linewidth=2, color=black, label='$m_\mathrm{'+comp_string_mean+'}, \mathrm{theory}$')
        
        xlabel('$\omega / 2\pi$ {Hz}' )
        ylabel('abs($\hat{m}\cdot 1000$)')
    
        ymin, ymax = ylim()
        yticks(np.linspace(ymin,ymax, 5))    
        
        rcParams['legend.fontsize'] = self.scale*8
        legend(loc=0)
        
        Tafel_Fabrik.new_panel(1, 0, r'B')
        plot(self.omegas_sim/(2*np.pi),angle_original(np.angle(self.M1_sim[comp_number_mean,:]))/(2.*np.pi),'.', 
             linewidth=2, color=black, label='$m_\mathrm{'+comp_string_mean+'}$')
        plot(self.omegas_num/(2*np.pi),angle_original(np.angle(self.M1_num[comp_number_mean,:]))/(2.*np.pi),'*',
             linewidth=2, color=black, label='$m_\mathrm{'+comp_string_mean+'}, \mathrm{theo., nonlin.}$')
        plot(self.omegas_theo/(2*np.pi),np.angle(self.M1_theo[comp_number_mean,:])/(2.*np.pi),
             linewidth=2, color=black, label='$m_\mathrm{'+comp_string_mean+'}, \mathrm{theory}$')
        
        ymin, ymax = ylim()
        yticks(np.hstack((np.linspace(ymin,ymax, 5),0.)))    
        
        xlabel('$\omega / 2\pi$ {Hz}' )
        ylabel('phase($\hat{m}/(2\pi)$)')
        
#        legend(loc=0)    
                
        Tafel_Fabrik.new_panel(0, 1, r'C')
    
        plot(self.omegas_theo/(2*np.pi),10**5*np.abs(self.C1_theo[comp_number_corr,:])/2.,
             linewidth=2, color=black)#, label='$c_\mathrm{ee}, \mathrm{theory}$')
        
        plot(self.omegas_theo/(2*np.pi),10**5*np.abs(self.C1_S_m_theo[comp_number_corr,:])/2.,
             linewidth=2, color='blue', label='$c_\mathrm{'+comp_string_corr+',S,m}$')
        plot(self.omegas_theo/(2*np.pi),10**5*np.abs(self.C1_S_h_theo[comp_number_corr,:])/2.,
             linewidth=2, color='red', label='$c_\mathrm{'+comp_string_corr+',S,h}$')
        plot(self.omegas_theo/(2*np.pi),10**5*np.abs(self.C1_a_m_theo[comp_number_corr,:])/2.,
             linewidth=2, color='orange')#, label='$c_\mathrm{'+comp_string_corr+',a,m}$')    
       
        plot(self.omegas_theo/(2*np.pi),10**5*np.abs(self.C1_S_m_theo[comp_number_corr,:]+self.C1_S_h_theo[comp_number_corr,:])/2.,
             linewidth=2, color='purple', label='$c_\mathrm{'+comp_string_corr+',S,m}+c_\mathrm{'+comp_string_corr+',S,h}$')
        
        plot(self.omegas_sim[1:]/(2*np.pi),10**5*np.abs(self.C1_sim[comp_number_corr,1:]),'.',
             linewidth=2, color=black)#, label='$c_\mathrm{ee}$')
        
        plot(self.omegas_num/(2*np.pi),10**5*np.abs(self.C1_num[comp_number_corr,:]),'*',
             linewidth=2, color=black)#, label='$c_\mathrm{ee}, \mathrm{theo, nonlin.}$')
    
        ymin, ymax = ylim()
        yticks(np.linspace(0.,ymax, 5))
            
        xlabel('$\omega / 2\pi$ {Hz}' )
        ylabel('abs($\hat{C} \cdot 10^5$)')
            
        legend(loc=0)
        
        Tafel_Fabrik.new_panel(1, 1, r'D')
        
        plot(self.omegas_theo/(2*np.pi),np.angle(self.C1_theo[comp_number_corr,:])/(2.*np.pi),
             linewidth=2, color=black)#, label='$c_\mathrm{'+comp_string_corr+'}, \mathrm{theory}$')
        
        plot(self.omegas_theo/(2*np.pi),np.angle(self.C1_S_m_theo[comp_number_corr,:])/(2.*np.pi),
             linewidth=2, color='blue')#, label='$c_\mathrm{ee}, \mathrm{S,m}$')
        plot(self.omegas_theo/(2*np.pi),np.angle(self.C1_S_h_theo[comp_number_corr,:])/(2.*np.pi),
             linewidth=2, color='red')#, label='$c_\mathrm{ee}, \mathrm{S,h}$')
        plot(self.omegas_theo/(2*np.pi),np.angle(self.C1_a_m_theo[comp_number_corr,:])/(2.*np.pi),
             linewidth=2, color='orange', label='$c_\mathrm{ee}, \mathrm{a,m}$')
        plot(self.omegas_sim[1:]/(2*np.pi),angle_original(np.angle(self.C1_sim[comp_number_corr, 1:]))/(2.*np.pi),'.', 
             linewidth=2, color=black)#, label='$c_\mathrm{'+comp_string_corr+'}$')
       
        plot(self.omegas_num/(2*np.pi),angle_original(np.angle(self.C1_num[comp_number_corr,:]))/(2.*np.pi),'*',
             linewidth=2, color=black)#, label='$c_\mathrm{'+comp_string_corr+'}, \mathrm{theo, nonlin.}$')
     
        ymin, ymax = ylim()
        yticks(np.hstack((np.linspace(ymin,ymax, 5),0.)))
              
        xlabel('$\omega / 2\pi$ {Hz}' )
        ylabel('phase($\hat{C}/(2\pi)$)')
     
        legend(loc=0)
        
        figurename = '/Correlation_and_meanact_compound_figures/Meanact_'+comp_string_mean+'_Correlation_'+comp_string_corr+'_splitted_theo_freqspace_h0='+str(self.h_ext)+'_T='+str(self.T_sim)+self.suffix_general        
            
        savefig(figurepath_default + figurename + '.pdf')
#        savefig(figurepath_default + figurename + '.eps')
        plt.savefig(figurepath_default + figurename+ '.svg', format="svg")
        os.system('inkscape --without-gui --export-eps='+figurepath_default + figurename+'.eps '+figurepath_default + figurename+'.svg')
        
    ###########################################################################
    ### First three harmonics of the mean activities ##########################
    ###########################################################################    
    def plot_three_Fourier_mean(self,fig_number):
        n_horz_panels = 2
        n_vert_panels = 3
        
        rcParams['axes.labelsize']  = self.scale*8
        rcParams['legend.fontsize'] = self.scale*6
    
        Tafel_Fabrik = create_fig_plos(fig_number, self.scale, self.width, n_horz_panels, n_vert_panels)
        
        Tafel_Fabrik.new_panel(0, 0, 'A')
        if(self.single_pop==0):
            plot(self.omegas_sim/(2*np.pi), np.real(self.M0_sim[self.E]),'.',markersize=4,
                 linewidth=1.5, color=black, label='$m_\mathrm{e}$')
        plot(self.omegas_sim/(2*np.pi), np.real(self.M0_sim[self.I]),'.',markersize=4,
             linewidth=1.5, color=midgray, label='$m_\mathrm{i}$')
        if(self.single_pop==0):
            plot(self.omegas_num/(2*np.pi), np.real(self.M0_num[self.E,:]),'*',markersize=4,
                 linewidth=1.5, color=black, label='$m_\mathrm{e}, \mathrm{theo, nonlin.}$')
        plot(self.omegas_num/(2*np.pi), np.real(self.M0_num[self.I,:]),'*',markersize=4,
             linewidth=1.5, color=midgray, label='$m_\mathrm{i}, \mathrm{theo, nonlin.}$')    
        if(self.single_pop==0):
            plot(self.omegas_theo/(2*np.pi), np.real(self.M0_theo[self.E,:]),
                 linewidth=1.5, color=black, label='$m_\mathrm{e}, \mathrm{theory}$')
        plot(self.omegas_theo/(2*np.pi), np.real(self.M0_theo[self.I,:]),
             linewidth=1.5, color=midgray, label='$m_\mathrm{i}, \mathrm{theory}$')
        
        xlabel('$\omega/2\pi$' )
        ylabel('$\hat{M}_0$')    
        
        
        legend(loc=0)
        
        Tafel_Fabrik.new_panel(1, 0, 'B')
        if(self.single_pop==0):
            loglog(self.omegas_sim/(2*np.pi), self.M0_sim[self.E],'.',markersize=4,
                   linewidth=1, color=black, label='$M^{0}_\mathrm{e}$')
        loglog(self.omegas_sim/(2*np.pi), self.M0_sim[self.I],'.',markersize=4,
               linewidth=1, color=midgray, label='$M^{0}_\mathrm{i}$')
        if(self.single_pop==0):
            loglog(self.omegas_sim[1:]/(2*np.pi), np.abs(self.M1_sim[self.E,1:]),'.',markersize=4,
                   linewidth=1.5, color=black, label='$M^{1}_\mathrm{exc.}$')
        loglog(self.omegas_sim[1:]/(2*np.pi), np.abs(self.M1_sim[self.I,1:]),'.',markersize=4,
               linewidth=1.5, color=midgray, label='$M^{1}_\mathrm{inh.}$')
        if(self.single_pop==0):
            loglog(self.omegas_sim[1:]/(2*np.pi), np.abs(self.M2_sim[self.E,1:]),'.',markersize=4,
                   linewidth=1.5, color=black, label='$M^{2}_\mathrm{exc.}$')
        loglog(self.omegas_sim[1:]/(2*np.pi), np.abs(self.M2_sim[self.I,1:]),'.',markersize=4,
               linewidth=1.5, color=midgray, label='$M^{2}_\mathrm{inh.}$')
        
        
        xlabel('$\omega/2\pi$' )
        ylabel('Fourier comp. of mean (abs))')
    
        
        legend(loc=0)
        
        Tafel_Fabrik.new_panel(0, 1, 'C')
        if(self.single_pop==0):
            plot(self.omegas_sim/(2*np.pi), np.abs(self.M1_sim[self.E,:]) * 10**1,'.',markersize=4,
                 linewidth=1.5, color=black, label='$m_\mathrm{exc.}$')
        plot(self.omegas_sim/(2*np.pi), np.abs(self.M1_sim[self.I,:]) * 10**1,'.',markersize=4,
             linewidth=1.5, color=midgray, label='$m_\mathrm{inh.}$')
        if(self.single_pop==0):
            plot(self.omegas_num/(2*np.pi), np.abs(self.M1_num[self.E,:]) * 10**1,'*',markersize=4,
                 linewidth=1.5, color=black, label='$m_\mathrm{exc.}, \mathrm{theo, nonlin.}$')
        plot(self.omegas_num/(2*np.pi), np.abs(self.M1_num[self.I,:]) * 10**1,'*',markersize=4,
             linewidth=1.5, color=midgray, label='$m_\mathrm{inh.}, \mathrm{theo, nonlin.}$')
        if(self.single_pop==0):
            plot(self.omegas_theo/(2*np.pi), 10**1 * np.abs(self.M1_theo[self.E,:])/2.,
                 linewidth=1.5, color=black, label='$m_\mathrm{exc.}, \mathrm{theory}$')
        plot(self.omegas_theo/(2*np.pi), 10**1 * np.abs(self.M1_theo[self.I,:])/2.,
             linewidth=1.5, color=midgray, label='$m_\mathrm{inh.}, \mathrm{theory}$')
        
        ymin, ymax = ylim()
        yticks(np.linspace(0.,ymax, 5))
        
        plot([self.f_res_mean,self.f_res_mean], [0.,ymax], linewidth=2, color=black)    
        
        xlabel('$\omega/2\pi$' )
        ylabel('abs($\hat{M}_1\cdot 10 ^{1}$)')
           
        
        legend(loc=0)
        
        Tafel_Fabrik.new_panel(1, 1, 'D')    
        if(self.single_pop==0):        
            plot(self.omegas_sim/(2*np.pi), angle_original(np.angle(self.M1_sim[self.E,:])),'.',markersize=4, 
                 linewidth=1.5, color=black, label='$m_\mathrm{exc.}$')
        plot(self.omegas_sim/(2*np.pi), angle_original(np.angle(self.M1_sim[self.I,:])),'.',markersize=4, 
             linewidth=1.5, color=midgray, label='$m_\mathrm{inh.}$')
        if(self.single_pop==0):        
            plot(self.omegas_num/(2*np.pi), angle_original(np.angle(self.M1_num[self.E,:])),'*',markersize=4,
                 linewidth=1.5, color=black,   label='$m_\mathrm{exc.}, \mathrm{theo, nonlin.}$')
        plot(self.omegas_num/(2*np.pi), angle_original(np.angle(self.M1_num[self.I,:])),'*',markersize=4,
             linewidth=1.5, color=midgray, label='$m_\mathrm{inh.}, \mathrm{theo, nonlin.}$')    
        if(self.single_pop==0):        
            plot(self.omegas_theo/(2*np.pi), np.angle(self.M1_theo[self.E,:]),
                 linewidth=1.5, color=black, label='$m_\mathrm{exc.}, \mathrm{theory}$')
        plot(self.omegas_theo/(2*np.pi), np.angle(self.M1_theo[self.I,:]),
             linewidth=1.5, color=midgray, label='$c_\mathrm{inh.}, \mathrm{theory}$')
        xlabel('$\omega/2\pi$' )
        ylabel('phase$(\hat{M}_1)/(2\pi)$')
        
        legend(loc=0)
        
        Tafel_Fabrik.new_panel(0, 2, 'E')    
        if(self.single_pop==0):        
            plot(self.omegas_sim/(2*np.pi), np.abs(self.M2_sim[self.E,:]) * 10.**3,'.',markersize=4,
                 linewidth=1.5, color=black, label='$m_\mathrm{exc.}$')
        plot(self.omegas_sim/(2*np.pi), np.abs(self.M2_sim[self.I,:]) * 10.**3,'.',
             linewidth=1.5, color=midgray, label='$m_\mathrm{inh.}$')
        if(self.single_pop==0):        
            plot(self.omegas_num/(2*np.pi), np.abs(self.M2_num[self.E,:]) * 10.**3,'*',markersize=4,
                 linewidth=1.5, color=black, label='$m_\mathrm{exc.}, \mathrm{theo, nonlin.}$')
        plot(self.omegas_num/(2*np.pi), np.abs(self.M2_num[self.I,:]) * 10.**3,'*',markersize=4,
             linewidth=1.5, color=midgray, label='$m_\mathrm{inh.}, \mathrm{theo, nonlin.}$')    
            
        ymin, ymax = ylim()
        yticks(np.linspace(0.,ymax, 5))
    
        xlabel('$\omega/2\pi$' )
        ylabel('abs($\hat{M}_{2} \cdot 10 ^{3} $)')
       
        legend(loc=0)
        
        Tafel_Fabrik.new_panel(1, 2, 'F')
        if(self.single_pop==0):
            plot(self.omegas_sim/(2*np.pi), angle_original(np.angle(self.M2_sim[self.E,:])),'.',markersize=4, 
                 linewidth=1.5, color=black, label='$m_\mathrm{exc.}$')
        plot(self.omegas_sim/(2*np.pi), angle_original(np.angle(self.M2_sim[self.I,:])),'.',markersize=4, 
             linewidth=1.5, color=midgray, label='$m_\mathrm{inh.}$')
        if(self.single_pop==0):        
            plot(self.omegas_num/(2*np.pi), angle_original(np.angle(self.M2_num[self.E,:])),'*',markersize=4,
                 linewidth=1.5, color=black, label='$cm_\mathrm{exc.}, \mathrm{theo, nonlin.}$')
        plot(self.omegas_num/(2*np.pi), angle_original(np.angle(self.M2_num[self.I,:])),'*',markersize=4,
             linewidth=1.5, color=midgray, label='$m_\mathrm{inh.}, \mathrm{theo, nonlin.}$')
        
        ymin, ymax = ylim()
        yticks(np.linspace(ymin,ymax, 5))    
        
        xlabel('$\omega/2\pi$' )
        ylabel('phase$(\hat{M}_{2})/(2\pi)$')
        
        
        legend(loc=0)
        
        figurename = '/Overview_three_first_harmonics_mean/Mean_act_freqspace_three_harm_h0='+str(self.h_ext) +'_T='+str(self.T_sim)+self.suffix_general        
            
        savefig(figurepath_default + figurename + '.pdf')
#        savefig(figurepath_default + figurename + '.eps')
        plt.savefig(figurepath_default + figurename+ '.svg', format="svg")
        os.system('inkscape --without-gui --export-eps='+figurepath_default + figurename+'.eps '+figurepath_default + figurename+'.svg')
    ######################################################
    ### Three first Fourier components of correlations ###
    ######################################################
    def plot_three_Fourier_corr_comp(self, component_number, component_string, fig_number):
        n_horz_panels = 2
        n_vert_panels = 3
        
        rcParams['axes.labelsize']  = self.scale*8
        rcParams['legend.fontsize'] = self.scale*6
        
        Tafel_Fabrik = create_fig_plos(fig_number, self.scale, self.width, n_horz_panels, n_vert_panels)
        
        Tafel_Fabrik.new_panel(0, 0, 'A')
        
        plot(self.omegas_sim/(2*np.pi),10**5*self.C0_sim[component_number,:],'.',markersize=4,
             linewidth=1.5, color=black, label='$c_\mathrm{' + component_string + '}$')
        plot(self.omegas_num/(2*np.pi),10**5*self.C0_num[component_number,:],'*',markersize=4,
             linewidth=1.5, color=black, label='$c_\mathrm{'+component_string+'}, \mathrm{theo, nonlin.}$')
        plot(self.omegas_theo/(2*np.pi),10**5*self.C0_theo[component_number,:],
             linewidth=1.5, color=black, label='$c_\mathrm{'+component_string+'}, \mathrm{theory}$')
        
        ymin, ymax = ylim()
        yticks(np.linspace(ymin,ymax, 5))    
        
        xlabel('$\omega / 2\pi$ {Hz}' )
        ylabel('$\hat{C}_0\cdot 10^{5}$')
        
        
        legend(loc=0)
        
        Tafel_Fabrik.new_panel(1, 0, 'B')
        
        loglog(self.omegas_sim/(2*np.pi),np.abs(self.C0_sim[component_number,:]),'.',markersize=4,
               linewidth=1.5, color = black, label='$C^{0}_\mathrm{'+component_string+'}$')
        loglog(self.omegas_sim[1:]/(2*np.pi),np.abs(self.C1_sim[component_number,1:]),'.',markersize=4,
               linewidth=1.5, color = midgray, label='$C^{1}_\mathrm{'+component_string+'}$')
        loglog(self.omegas_sim[1:]/(2*np.pi),np.abs(self.C2_sim[component_number,1:]),'.',markersize=4,
               linewidth=1.5, color = lightgray, label='$C^{2}_\mathrm{'+component_string+'}$')
    
        xlabel('$\omega / 2\pi$ {Hz}' )
        ylabel('Fourier comp. of corr. (abs)')
    
        
        legend(loc=0)
        
        Tafel_Fabrik.new_panel(0, 1, 'C')
            
        plot(self.omegas_theo/(2*np.pi),10**5*np.abs(self.C1_S_m_theo[component_number,:])/2.,
             linewidth=1.5, color='blue', label='$c_\mathrm{'+component_string+',S,m}$')
        plot(self.omegas_theo/(2*np.pi),10**5*np.abs(self.C1_S_h_theo[component_number,:])/2.,
             linewidth=1.5, color='red', label='$c_\mathrm{'+component_string+',S,h}$')
        plot(self.omegas_theo/(2*np.pi),10**5*np.abs(self.C1_a_m_theo[component_number,:])/2.,
             linewidth=1.5, color='orange', label='$c_\mathrm{'+component_string+',a,m}$')    
       
        plot(self.omegas_theo/(2*np.pi),10**5*np.abs(self.C1_S_m_theo[component_number,:]+self.C1_S_h_theo[component_number,:])/2.,
             linewidth=2, color='purple', label='$c_\mathrm{'+component_string+',S,m}+c_\mathrm{'+component_string+',S,h}$')
    
        plot(self.omegas_theo/(2*np.pi),10**5*np.abs(self.C1_theo[component_number,:])/2.,
             linewidth=2, color=black)#, label='$c_\mathrm{'+component_string+'}, \mathrm{theory}$')
        
        plot(self.omegas_sim[1:]/(2*np.pi),10**5*np.abs(self.C1_sim[component_number,1:]),'.',markersize=4,
             linewidth=1.5, color=black)#, label='$c_\mathrm{'+component_string+'}$')
        
        plot(self.omegas_num/(2*np.pi),10**5*np.abs(self.C1_num[component_number,:]),'*',markersize=4,
             linewidth=1.5, color=black)#, label='$c_\mathrm{'+component_string+'}, \mathrm{theo, nonlin.}$')
        
        ymin, ymax = ylim()
        yticks(np.linspace(0.,ymax, 5))
        
        plot([self.f_res_mean,self.f_res_mean], [0.,ymax], linewidth=1, color=black)    
        plot([self.f_res_corr,self.f_res_corr], [0.,ymax], linewidth=1, color=black)    
            
        xlabel('$\omega / 2\pi$ {Hz}' )
        ylabel('abs($\hat{C} \cdot 10^5$)')
        
           
        legend(loc=0)
        
        Tafel_Fabrik.new_panel(1, 1, 'D')    
        plot(self.omegas_sim[1:]/(2*np.pi),angle_original(np.angle(self.C1_sim[component_number,1:]))/(2.*np.pi),'.',markersize=4, 
             linewidth=1.5, color=black, label='$c_\mathrm{'+component_string+'}$')
        
        plot(self.omegas_num/(2*np.pi),angle_original(np.angle(self.C1_num[component_number,:]))/(2.*np.pi),'*',markersize=4,
             linewidth=1.5, color=black, label='$c_\mathrm{'+component_string+'}, \mathrm{theo, nonlin.}$')
        
        plot(self.omegas_theo/(2*np.pi),np.angle(self.C1_theo[component_number,:])/(2.*np.pi),
             linewidth=1.5, color=black, label='$c_\mathrm{'+component_string+'}, \mathrm{theory}$')
    
        plot(self.omegas_theo/(2*np.pi),np.angle(self.C1_S_m_theo[component_number,:])/(2.*np.pi),
             linewidth=1.5, color='blue')#, label='$c_\mathrm{'+component_string+'}, \mathrm{S,m}$')
        plot(self.omegas_theo/(2*np.pi),np.angle(self.C1_S_h_theo[component_number,:])/(2.*np.pi),
             linewidth=1.5, color='red')#, label='$c_\mathrm{'+component_string+'}, \mathrm{S,h}$')
        plot(self.omegas_theo/(2*np.pi),np.angle(self.C1_a_m_theo[component_number,:])/(2.*np.pi),
             linewidth=1.5, color='orange')#, label='$c_\mathrm{'+component_string+'}, \mathrm{a,m}$')    
        
        ymin, ymax = ylim()
        yticks(np.linspace(ymin,ymax, 5))    
        
        xlabel('$\omega / 2\pi$ {Hz}' )
        ylabel('phase$(\hat{C}_1)/(2\pi)$')
        
        
        legend(loc=0)
        
        Tafel_Fabrik.new_panel(0, 2, 'E')    
        plot(self.omegas_sim[1:]/(2*np.pi),10**7*np.abs(self.C2_sim[component_number,1:]),'.',markersize=4,
             linewidth=1.5, color=black, label='$c_\mathrm{'+component_string+'}$')
        
        plot(self.omegas_num/(2*np.pi),10**7*np.abs(self.C2_num[component_number,:]),'*',markersize=4,
             linewidth=1.5, color=black, label='$c_\mathrm{'+component_string+'}, \mathrm{theo, nonlin.}$')
        
        ymin, ymax = ylim()
        yticks(np.linspace(0.,ymax, 5))    
        
        xlabel('$\omega / 2\pi$ {Hz}' )
        ylabel('abs($\hat{C}_{2}\cdot 10^{7}$)')
        
        legend(loc=0)
        
        Tafel_Fabrik.new_panel(1, 2, 'F')
        plot(self.omegas_sim[1:]/(2*np.pi),angle_original(np.angle(self.C2_sim[component_number,1:]))/(2.*np.pi),'.',markersize=4, 
             linewidth=1.5, color=black, label='$c_\mathrm{'+component_string+'}$')
        
        plot(self.omegas_num/(2*np.pi),angle_original(np.angle(self.C2_num[component_number,:]))/(2.*np.pi),'*',markersize=4,
             linewidth=1.5, color=black, label='$c_\mathrm{'+component_string+'}, \mathrm{theo, nonlin.}$')
        
        ymin, ymax = ylim()
        yticks(np.linspace(ymin,ymax, 5))    
        
        xlabel('$\omega / 2\pi$ {Hz}' )
        ylabel('phase$(\hat{C}_{2})/(2\pi)$')
        
        
        legend(loc=3)   
        
        figurename = '/Overview_three_first_harmonics_'+component_string+'/Correlation_freqspace_three_harm_'+component_string+'_h0='+str(self.h_ext)+'_N_pop=' +'_T='+str(self.T_sim)+self.suffix_general        
            
        savefig(figurepath_default + figurename + '.pdf')
#        savefig(figurepath_default + figurename + '.eps')
        plt.savefig(figurepath_default + figurename+ '.svg', format="svg")
        os.system('inkscape --without-gui --export-eps='+figurepath_default + figurename+'.eps '+figurepath_default + figurename+'.svg')
        
    def plot_comparison_second_to_first_Fouriercomp_corr(self, component_number, component_string, fig_number):
            n_horz_panels = 2
            n_vert_panels = 1
    
            
            rcParams['axes.labelsize']  = self.scale*8
            rcParams['legend.fontsize'] = self.scale*6
            
            Tafel_Fabrik = create_fig_plos(fig_number, self.scale, self.width, n_horz_panels, n_vert_panels)
            
            
            Tafel_Fabrik.new_panel(0, 0, 'A')
            
            plot(self.omegas_sim[1:]/(2*np.pi),np.abs(self.C2_sim[component_number,1:])/np.abs(self.C1_sim[component_number,1:]),'.',
                 markersize=4,linewidth=1.5, color=black)#, label='$c_\mathrm{'+component_string+'}$')
            
            plot(self.omegas_num/(2*np.pi),np.abs(self.C2_num[component_number,:])/np.abs(self.C1_num[component_number,:]),'*',
                 markersize=4,linewidth=1.5, color=black)#, label='$c_\mathrm{'+component_string+'}, \mathrm{theo, nonlin.}$')
            
            ymin, ymax = ylim()
            yticks(np.linspace(0.,ymax, 5))
            
            plot([self.f_res_mean,self.f_res_mean], [0.,ymax], linewidth=1, color=black)    
            plot([self.f_res_corr,self.f_res_corr], [0.,ymax], linewidth=1, color=black)    
                
            xlabel('$\omega / 2\pi$ {Hz}' )
            ylabel('abs($\hat{C} \cdot 10^5$)')
            
            legend(loc=0)
            
            Tafel_Fabrik.new_panel(1, 0, 'B')    
            plot(self.omegas_sim[1:]/(2*np.pi),angle_original(np.angle(self.C1_sim[component_number,1:]))/(2.*np.pi),'.',
                 markersize=4, linewidth=1.5, color=black, label='$c_\mathrm{'+component_string+'}$')
            
            plot(self.omegas_num/(2*np.pi),angle_original(np.angle(self.C1_num[component_number,:]))/(2.*np.pi),'*',
                 markersize=4,linewidth=1.5, color=black, label='$c_\mathrm{'+component_string+'}, \mathrm{theo, nonlin.}$')
            
            
            ymin, ymax = ylim()
            yticks(np.linspace(ymin,ymax, 5))    
            
            xlabel('$\omega / 2\pi$ {Hz}' )
            ylabel('phase$(\hat{C}_1)/(2\pi)$')
            
            legend(loc=0)
            
            
            #figurename = '/Overview_three_first_harmonics_'+component_string+'/Correlation_freqspace_three_harm_'+component_string+'_h0='+str(self.h_ext)+'_N_pop=' +'_T='+str(self.T_sim)+self.suffix_general        
                
#            savefig(figurepath_default + figurename + '.pdf')
#            savefig(figurepath_default + figurename + '.eps')